<?php
#
# Copyright(C) 2004-2005 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#            Jean Gillaux <jean@inl.fr>
#            Damien Boucard <damien.boucard AT inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

#if set to "true", user of the interface will be provided a way to change language on the fly
$lang_override=true;
#[default] language of the interface
$lang='en';
#if one adds languages in messages.php, also add it to this array
$available_langs=array('fr','en');

#NOT TO BE MODIFIED
require_once("include/security.php");
if ($lang_override) {
	if (isset($_GET['lang'])) {
		if (preg_match('/^[a-z]{2}$/',$_GET['lang']))
			$_SESSION['lang']=$_GET['lang'];
	}

  if (isset($_SESSION['lang']))
  {
    if (check_lang($_SESSION['lang']))
    {
      $lang=$_SESSION['lang'];
    }
  }
}

if (!isset($lang)){
  $lang="fr";
}

$_SESSION['lang'] = $lang;

$policyfile="/etc/network/firewall/specs/spec.xml";

#Is this interface just a demo (no need for write permissions)
#$is_demo=false;

$show_subjects=true;

#Whether the firewall is NuFW or plain netfilter
$nufw_firewall=true;
$support_periods=true;

#Whether the firewall has Layer 7 filtering capabilities
#Be careful: before enabling you must have both kernel and iptables patched.
$l7_firewall=false;
$l7_mask="0x007f0000";
$l7_command = "/usr/sbin/nulayer7";
$l7_protos_file = "include/l7-protos";

#Change this if you know what you're doing ; tricky network topologies only!
$disable_check_net=false;

#Do not change this ; subjects have to be shown separetely when setting up a NuFW firewall
if ($nufw_firewall)
{
  $show_subjects=true;
}

# Display image as logo
$logo_nuface = "images/nupik.gif";

$datadir="/var/lib/nuface";
$logdir="/var/log/nuface";
$lockdir="/var/lib/nuface";

$tmpdir="/tmp";


$rules_dir="/etc/nuface/dyn";
$nufw_rules_dir="/etc/nuface/dyn/nufw";
$std_rules_dir="/etc/nuface/dyn/standard";
$nufw_rules_file="fwd_rules";
$std_rules_file="nonufw_rules";
$nupyf_ldap_file="ldap_objects";
$nupyf_conf_file="nupyf.conf";


$network_desc_dir="/etc/nuface/desc";
$network_desc_file="desc.xml";
#$network_desc_file=array("desc.xml","desc2.xml");

$periods_file = "/tmp/periods.xml";
$nupyf_command="/usr/sbin/nupyf";
$nuperiod_command="/usr/sbin/nuperiod";
$sudo_command="/usr/bin/sudo";

$network_script_dir="/etc/nuface";
$firewall_script="/etc/rc.d/init.d/nupyf";

## Begin of duplication section ##
# These settings are experimental.
# Use them at your own risk.
$support_duplication=false;
# Following setting are not used if $support_duplication=false
$duplication_script="/usr/sbin/sync_firewalls.sh";
$ssh_user="nuface";
$ssh_host="firewall-slave";
$remote_rules_dir="/etc/network/firewall/dyn";
$remote_sudo_command="/usr/bin/sudo";
$remote_firewall_script="/etc/init.d/init-firewall";
## End of duplication section ##

$manage_input=true;
$manage_output=true;
$manage_nat=true;

if ($lang=='fr')
{
  if ($nufw_firewall)
  {
    $pages_display=array("action","nat","acls","protocoles");
    if ($l7_firewall)
    {
      array_push($pages_display,"rgles l7");
    }
    array_push($pages_display,"sujets","ressources","applications","lments de travail");
    if ($support_periods)
      array_push($pages_display,"plages de temps");
  } else {
    $pages_display=array("action","nat","acls","protocoles");
    if ($l7_firewall)
    {
      array_push($pages_display,"rgles l7");
    }
    if ($show_subjects)
    {
      array_push($pages_display,"sujets");
    }
    array_push($pages_display,"ressources","lments de travail");
  }
} else {
  if ($nufw_firewall)
  {
    #$pages_display=array("action","nat","acls","protocols","subjects","resources","applications","floatings");
    $pages_display=array("action","nat","acls","protocols");
    if ($l7_firewall)
    {
      array_push($pages_display,"l7 rules");
    }
    array_push($pages_display,"subjects","resources","applications","floatings");
    if ($support_periods)
      array_push($pages_display,"periods");
  } else {
    $pages_display=array("action","nat","acls","protocols");
    if ($l7_firewall)
    {
      array_push($pages_display,"l7 rules");
    }
    if ($show_subjects)
    {
      array_push($pages_display,"subjects");
    }
    array_push($pages_display,"resources","floatings");
  }
}
$logout_link=0;

#Whether to load the edenavbar for a full EdenWall integration with nuconf/nulog/etc.
#$edenwall_integration=1;

# wheter to use getent to retrieve groups information: name and gid
#$use_getent_groups=1;
#Wether to decode UTF8 (if conversion is needed)
#$decode_groups_from_utf8=false;
# path to file (in /etc/group format) to use instead of system conf
# (use_getent_groups must be set to 1)
#$groups_file='/tmp/groups.txt';
# path to file representing local groups, typicaly /etc/groups
# use it if local groups must not be displayed in nufw elts groups lists
$sys_groupfile = '/etc/group';


# do not generate unused bichains with nupyf
$nupyf_no_same_iface = 1;

# do not check inclusion and overlaping on enterprise networks
$nupyf_no_check_net = 0;

if ($nufw_firewall){
  $pages_list=array("index","nat","acls","protocols");
  if ($l7_firewall)
  {
    array_push($pages_list,"l7rules");
  }
  array_push($pages_list,"subjects","ressources","applications","floatings");
  if ($support_periods)
  {
    array_push($pages_list,"periods");
  }
}else{
  $pages_list=array("index","nat","acls","protocols");
  if ($l7_firewall)
  {
    array_push($pages_list,"l7rules");
  }
  if ($show_subjects)
  {
    array_push($pages_list,"subjects");
  }
  array_push($pages_list,"ressources","floatings");
}
