<?php
#
# Copyright(C) 2004-2007 INL http://www.inl.fr/
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#            Jean Gillaux <jean@inl.fr>
#            Damien Boucard <damien.boucard AT inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

session_start();

$title='acls';
$singtitle='acl';
require_once ("include/security.php");
require_once ("/etc/nuface/config.php");
require_once ("include/messages.php");
$header_onclick="return ask_list_change(new Array('sortcat'),'$gal_confirm_change_order')";
require_once ("include/headers.php");
require_once ("include/function.php");
require_once ("include/types.php");
require_once ("include/display.php");

$expolicy=unserialize($_SESSION['document']);
$used_desc = $_SESSION['used_desc'];
if (!$expolicy){
  display_openfile_menu();
#  add_log($gal_load_valid_xml_file);
  log_and_exit(-1);
}

$acls=&$expolicy->acls;
$protocols=$expolicy->protocols;
$periods=$expolicy->periods;
$groups=&$expolicy->groups;
$applications=$expolicy->applications;
$ressources=$expolicy->ressources;
$descs=$expolicy->descs;

if (!$show_subjects)
{
  sync_subjects(&$expolicy);
}
$subjects=$expolicy->subjects;


$new_name=$_REQUEST['name'];
$new_acl=$_REQUEST['new_acl'];
$new_acl_group=$_REQUEST['new_acl_group']; # Group of the new acl.
$new_group=$_REQUEST['new_group'];
$delete=$_REQUEST['delete'];
$ch_name=$_REQUEST['ch_name'];
$acl_nb=$_REQUEST['acl_nb'];
$ch_protocol=$_REQUEST['protocol'];
$ch_period=$_REQUEST['period'];
$ch_group=$_REQUEST['group'];
$ch_application=$_REQUEST['application'];
$ch_subject=$_REQUEST['subject'];
$ch_ressource=$_REQUEST['ressource'];
$ch_decision=$_REQUEST['decision'];
$ch_acl=$_REQUEST['acl'];
$macl=$_REQUEST['macl'];
$nulog=$_REQUEST['nulog'];
$up=$_REQUEST['up'];
$down=$_REQUEST['down'];
$aclorder=$_REQUEST['dndSort'];
$ch_comment=$_REQUEST['comment'];
$gr_enabled=$_REQUEST['gr_enabled'];
$modify_groups=$_REQUEST['modify_groups'];
$del_grp_id = $_REQUEST['del_grp'];
$disp_bichain = $_REQUEST['bichain'];

$chain_from = $_REQUEST['chainfrom'];
$chain_to = $_REQUEST['chainto'];



#INPUT STRICT CHECKING
if (!check_comment($new_name))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_nb($ch_protocol))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_nb($ch_period))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_nb($ch_group))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_nb($new_acl_group))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_nb($ch_application))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_nb($ch_subject))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_nb($ch_ressource))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_decision($ch_decision))
{
    add_log($gal_elt_not_exists." no decision $ch_decision");
    log_and_exit(-1);
}

if (!check_nb($ch_acl))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_aclorder($aclorder))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (isset($nulog) and ($nulog==1))
{
  add_log($from_nulog_message);
}

$bichains = unserialize($_SESSION['bichains']);

#get order for every bichain
$aclorders = array();
#print "aclorders:"; var_dump($aclorders);

$valid=0;
#make bichain with from/to if available
if((isset($chain_from) && $chain_from != '') && (isset($chain_to) && $chain_to != '')){
    $disp_bichain = "$chain_from-$chain_to";
}
$bichain_label = $disp_bichain;
if (!isset($disp_bichain) or $disp_bichain == '' or ($disp_bichain=='View All'))
{
  $valid=1;
  $disp_bichain = 0;
}else{
  foreach($bichains as $key=>$data)
  {
    if (strcmp(($data['label']),$disp_bichain)!=0)
    {
      continue;
    }
    //print "disp: $disp_bichain, label".$data['label'];
    $valid=1;
    $disp_bichain = $key;
    break;
  }
}
if ($valid!=1)
{
  add_log($mess_bad_bichain);
  add_log("disp_bichain: $disp_bichain");
  log_and_exit(-1);
}


$aclorders[$bichain_label] = $_REQUEST['dndSort_BICHAIN'];

if (!isset($ch_acl) or ($ch_acl == ""))
{
  foreach($acls->ordered_list_tab() as $key => $foo){
    $myacl = $acls->get_elt($key);
    if (!isset($myacl->from) or ($myacl->from==""))
    {
      add_log($mess_incomplete_object);
      $ch_acl=$myacl->ID;
      break;
    }
    if (!isset($myacl->to) or ($myacl->to==""))
    {
      add_log($mess_incomplete_object);
      $ch_acl=$myacl->ID;
      break;
    }
    if (!isset($myacl->decision) or ($myacl->decision==""))
    {
      $ch_acl=$myacl->ID;
      add_log($mess_incomplete_object);
      break;
    }
  }
}

# store in session the acl to display in detail
# or get ch_acl from session
if (isset($ch_acl) && $ch_acl == "") {
  unset($ch_acl);
} else if (isset($ch_acl)) {
    $_SESSION['acl'] = $ch_acl;
} else if (isset($bichain_label)) {
    $ch_acl = $_SESSION['acl'];
}

print_acls_onload($bichains, $disp_bichain);
print_js_groups_tab($groups);
print_javascript(acls_dnd_init(get_chains($expolicy, $used_desc)));

if ((isset($down)) and ($down==1))
  $up=-1;

/* set is_used field for groups */
foreach($acls->ordered_list_tab() as $key => $foo){
    $myacl = $acls->get_elt($key);
    foreach ($groups->list_tab() as $keyg=>$foog){
        $group=$groups->get_elt($keyg);
        if($myacl->group == $group->ID){
            $group->is_used = true;
        }else{
            $group->is_used = false;
        }
        $groupc = $group->cloneobj();
        $groups->del_elt($group->ID);
        $groups->add_elt($groupc);
    }
}

if (isset($new_name) and isset($new_acl) and isset($new_acl_group) and $new_acl==1)
{
  $new_acl=array();
  $new_acl{'name'}=$new_name;
  $new_acl{'modified'}=date("D d M Y");
  $new_acl{'group'}=$new_acl_group;
  $acl=new acl($new_acl,'data',$acls->new_id());
  $ch_group = $new_acl_group;
  $ch_acl = $acl->ID;
  $acls->add_elt($acl);
  $_SESSION['document']=serialize($expolicy);
  $_SESSION['modified']=1;
}
else if (isset($modify_groups) and $modify_groups==1)
{
  $modified=0;
    foreach ($groups->list_tab() as $key=>$foo)
    {
      $local_mod=0;
      $received=array();
      $group=$groups->get_elt($key);
      if (isset($_REQUEST["enabled".$key]) and $_REQUEST["enabled".$key]=='on')
        $received['enabled']=1;
      else
        $received['enabled']=0;
      if (isset($_REQUEST["name".$key]) and check_comment($_REQUEST["name".$key]))
      {
        $received['name']=$_REQUEST["name".$key];
      }
      else
      {
        $received['name']=$key;
      }
      if (isset($_REQUEST["comment".$key]) and check_comment($_REQUEST["comment".$key]))
        $received['comment']=$_REQUEST["comment".$key];
      else
        $received['comment']="";

      if ($received['enabled'] != $group->enabled)
        $local_mod++;
      if ($received['name'] != $group->name)
        $local_mod++;
      if ($received['comment'] != $group->comment)
        $local_mod++;
      $grp_deleted = false;
      if($_REQUEST['del_grp'][$group->ID] == 'on' && !$group->is_used){/* delete group if checkbox is checked */
          $groups->del_elt($group->ID);
          $grp_deleted = true;
          #print_r($groups);
          $modified++;
      }
      if ($local_mod>0 && !$grp_deleted)
      {
        $groups->del_elt($group->ID);
        $new_grp=new group($received,'data',$group->ID);
        #print_r($_REQUEST['del_grp']);
        $groups->add_elt($new_grp);
        $modified++;
      }
    }
  if ($modified>0)
  {
    $_SESSION['document']=serialize($expolicy);
    $_SESSION['modified']=1;
  }
}
else if ((isset($new_name) and (isset($new_group)) and ($new_group==1)))
{
  $new_group=array();
  $new_group{'name'}=$new_name;
  $new_group{'modified'}=date("D d M Y");
  $group=new group($new_group,'data',$groups->new_lower_id());
  $groups->add_elt($group);
  $_SESSION['document']=serialize($expolicy);
  $_SESSION['modified']=1;
}elseif (isset($ch_acl) and isset($ch_period) and isset ($ch_group) and isset($ch_protocol) and isset($ch_subject) and isset($ch_ressource) and isset($ch_decision) and isset($ch_name) and isset($ch_comment) and (!check_input_var('ress','name',$ch_name)))
{
  $tmp=$acls->get_elt($ch_acl);
  if (!isset($tmp))
  {
    add_log($gal_elt_not_exists." acl".$ch_acl);
    log_and_exit(-1);
  }
  $tmp=$groups->get_elt($ch_group);
  if (!isset($tmp) and ($ch_group!=0))
  {
    add_log($gal_elt_not_exists." group".$ch_group);
    log_and_exit(-1);
  }
  if ($ch_protocol != 0)
  {
    $tmp=$protocols->get_elt($ch_protocol);
    if (!isset($tmp) and ($ch_protocol!=0))
    {
      add_log($gal_elt_not_exists." proto".$ch_protocol);
      log_and_exit(-1);
    }
  }
  if ($ch_period != 0)
  {
    $tmp=$periods->get_elt($ch_period);
    if (!isset($tmp) and ($ch_period!=0))
    {
      add_log($gal_elt_not_exists." period".$ch_period);
      log_and_exit(-1);
    }
  }
  if ($nufw_firewall){
    if ($ch_application != 0)
    {
      $tmp=$applications->get_elt($ch_application);
      if (!isset($tmp) and ($ch_application!=0))
      {
        add_log($gal_elt_not_exists." app".$ch_application);
        log_and_exit(-1);
      }
    }
  }
  $tmp=$subjects->get_elt($ch_subject);
  if (!isset($tmp))
  {
    add_log($gal_elt_not_exists." sub".$ch_subject);
    log_and_exit(-1);
  }
  $ret=check_input_var('ress','comment',$ch_comment);
  if ($ret!=0)
  {
      add_log($gal_bad_param_specified."comment)");
      add_log($mess_bad_input_var{$ret});
      log_and_exit(-1);
  }
  $seen_mod=0;
  $my_acl=&$acls->get_elt_by_id($ch_acl);
  $received['ID']=$my_acl->ID;
  $received['from']=$ch_subject;
  if ($ch_subject!=$my_acl->from)
    $seen_mod++;
  $received['to']=$ch_ressource;
  if ($ch_ressource!=$my_acl->to)
    $seen_mod++;
  if ($ch_protocol != 0)
    $received['proto']=$ch_protocol;
  if ($ch_period != 0)
    $received['period']=$ch_period;
  $received['group']=$ch_group;
  if ($ch_group != $my_acl->group)
    $seen_mod++;
  if ($received['period']!=$my_acl->period)
    $seen_mod++;
  if ($received['proto']!=$my_acl->proto)
    $seen_mod++;
  if ($nufw_firewall)
  {
    if ($ch_application != 0)
      $received['with']=$ch_application;
    if ($ch_application!=$my_acl->with)
      $seen_mod++;
  }
  $received['comment']=$ch_comment;
  if ($ch_comment!=$my_acl->comment)
    $seen_mod++;
  $received['decision']=$ch_decision;
  if ($ch_decision!=$my_acl->decision)
    $seen_mod++;
  //$received['name']=$my_acl->name;
  $received['name']=$ch_name;
  if ($ch_name!=$my_acl->name)
    $seen_mod++;
  $received['modified']=$my_acl->modified;
  if ($seen_mod)
    $received['modified']=date("D d M Y");
  $acl_descsorts = $my_acl->descsorts;
  $received['descsorts'] = $acl_descsorts;
  $acls->del_elt($my_acl->ID);
  $new_acl=new acl($received,'data',$my_acl->ID);
  $acls->add_elt($new_acl);

//  if (isset($gr_enabled))
  {
    if ($gr_enabled == 'on')
      $gr_enabled=1;
    else if ($gr_enabled == 'off')
      $gr_enabled=0;
    $my_group = &$groups->get_elt_by_id($ch_group);
    if (($gr_enabled == 0) or ($gr_enabled == 1))
      $my_group->enabled = $gr_enabled;
  }
  $descs=&$expolicy->descs;
  $expolicy = check_acls_from_to($expolicy, $descs->elts[$used_desc]);
  $acls = $expolicy->acls;
  //var_dump($expolicy);
  $_SESSION['document']=serialize($expolicy);
  $_SESSION['modified']=1;
  #var_dump($acls);
}elseif (isset($delete))
{
  //if (preg_match($delete,'/^\d+$/'))
  if (!preg_match('/^\d+$/',$delete))
  {
    add_log($gal_bad_param);
    log_and_exit(-1);
  }
  $tmp=$acls->get_elt($delete);
  if (!isset($tmp))
  {
    add_log($gal_elt_not_exists." delete".$delete);
    log_and_exit(-1);
  }
  //print_r($acls);
  //print_r($delete);
  //print_r($tmp);
  $acls->del_elt($delete);
  $_SESSION['document']=serialize($expolicy);
  $_SESSION['modified']=1;
}elseif ((isset($macl)) and (isset($up)) and (($up==1) or ($up==-1)))
{
  $list=$acls->ordered_list_tab();
  if (!isset($list))
  {
    $list=array();
  }
  $current=0;$in=0;
  foreach ($list as $is=>$value)
  {
    $last=$current;
    $current=$is;
    if ($current == $macl)
      $in=1;
    if ($in==1)
    {
      if (($last==0) and ($up==1)) #Cannot bring top element up
        break;
      #bring an element down means bring the following element up
      if ($up==-1)
      {
        $up=1;
        continue;
      }
      $cur_elt=&$acls->get_elt($current);
      $last_elt=&$acls->get_elt($last);
     # add_log("Swapping elements ".$cur_elt->ID." and ".$last_elt->ID);
      $tmpid=$cur_elt->ID;
      $cur_elt->ID=$last_elt->ID;
      $last_elt->ID=$tmpid;
      $acl1=$acls->get_elt($cur_elt->ID);
      $acl2=$acls->get_elt($last_elt->ID);
      $acls->del_elt($cur_elt->ID);
      $acls->del_elt($last_elt->ID);
      $acls->add_elt($acl1,'data',$last_elt->ID);
      $acls->add_elt($acl2,'data',$cur_elt->ID);

      $_SESSION['document']=serialize($expolicy);
      $_SESSION['modified']=1;
      break;
    }
  }
}/*elseif((isset($ch_name)) and (preg_match("/^[a-zA-Z0-9\-\_\s]+$/",$ch_name)) and (isset($acl_nb)) and (preg_match("/^[0-9]+$/",$acl_nb)))
{
  //$cur_elt=&$acls->get_elt($acl_nb);
  $cur_elt=&$acls->get_elt_by_id($acl_nb);
  if (!isset($cur_elt))
  {
    add_log($gal_elt_not_exists." acl_nb".$acl_nb);
    log_and_exit(-1);
  }
  //print "setting {$cur_elt->name} to $ch_name";
  $cur_elt->name=$ch_name;
  $_SESSION['document']=serialize($expolicy);
}*/
/*var_dump($bichains);*/



if ($_SESSION['need_acl_recalc'] != 0)
{
  $expolicy = check_acls_from_to($expolicy,$descs->elts[$used_desc]);
  $_SESSION['document']=serialize($expolicy);
}


#
# Reorder acls.
# iterate over bichain and change order for acls if needed
foreach($aclorders as $bichain_name => $aclorder)
{
  if(!check_aclorder($aclorder) || $aclorder == ''){continue;}
  $tab2=array();
  $tab_order = array();
  $bichain = get_bichain_by_name($bichains, $bichain_name);
  foreach($acls->elts as $eid => $elt){
    //print_r($eid);
    //print_r($elt);
    $tid=$elt->ID;
    $tab2[$tid] = $elt->cloneobj();
    if(bichain_touches_acl($bichain, $elt)){
        $ord = $elt->get_order($_SESSION['used_desc'], $bichain['from'], $bichain['to']);
        $tab_order[$ord]=$elt->cloneobj();
    }
  }
  if(!isset($bichain)){
      continue;
  }
  $acls2=$acls;
  $done = false;
  $i = 1;
  foreach (explode('|',$aclorder) as $k => $v) {
    $acltmpx=$tab_order[$v];
    $oldid = $acltmpx->ID;
    #var_dump($acltmpx);
    #$acl_order = $acltmpx->get_order($used_desc, $bichain['from'], $bichain['to']);
    #print "order: ".$acl_order.",$i\n";
    $acltmpx->set_order($used_desc, $bichain['from'], $bichain['to'], $i,$acltmpx->get_max_elt_order_id());
    #print "acls modifi�"; var_dump($acltmpx);
    $tab2[$oldid] = $acltmpx;
    #var_dump($acltmpx->descsorts);

    $i++;
  }
  $newacls=new obj_set($tab2);
  $acls=$newacls;
  $expolicy->acls=$acls;
  $_SESSION['document']=serialize($expolicy);
  $_SESSION['modified']=1;

}


$acl=$_REQUEST['acl'];
if (!check_nb($acl))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}
//$acl_menu_class= isset($acl)? "aclmenu" : "aclmenu_ext";
$acl_menu_class = "aclmenu_ext";
echo "<div class=\"$acl_menu_class\" id=\"c1\">\n";
//print "<table>\n";
//echo '<form onsubmit="aclHandle()" action="acls.php" method="post">';
#echo '<ul id="sortcat" class="sortul">'."\n";
$mybichain=$bichains[$disp_bichain];
#var_dump($bichains);
$dndSorts = dndsort_inputs($bichains);
#echo '</ul>';
if (isset($bichain_label)){
    echo html_acls_bichain($disp_bichain, $bichains, $expolicy);
}else{
    echo html_all_acls($expolicy, $chain_from, $chain_to, $ch_group);
}
print "\n</div>\n";

begin_content_detail();
#
# Display Acl detail
#
if (isset($ch_acl)){

  $acl = $ch_acl;
  print "<div class=\"acledit_tab\">";
  $ressources=$expolicy->ressources;
  $subjects=$expolicy->subjects;
  $protocols=$expolicy->protocols;
  $periods=$expolicy->periods;
  $groups=$expolicy->groups;
  $applications=$expolicy->applications;
  $my_acl=$acls->get_elt_by_id($acl);
  //print "ch_acl $ch_acl\n"; var_dump($acls); var_dump($my_acl);
  if(!isset($aclorder))
    $my_acl = $acls->get_elt($acl);
#  print_r($my_acl);
  print "<h3>[".$my_acl->ID."] ".$my_acl->name."</h3>\n";

  $from=$subjects->get_elt(($my_acl->from));
  $to=$ressources->get_elt($my_acl->to);
  $proto=$protocols->get_elt($my_acl->proto);
  $period=$periods->get_elt($my_acl->period);
  $group=$groups->get_elt($my_acl->group);
  $with=$applications->get_elt($my_acl->with);

  print "<div class=\"".$my_acl->decision."\">[".$proto->name."][".$with->name."]".$from->name." =>".$to->name."</div>\n";

  echo '<div class=bichain><input id="show_acl_bichains" type="submit"  value="'.$mess_acl_bichains.'" onclick="show_hide_panel(YAHOO.example.panel_bichains.dlg2);";/></div>';
  echo "<div id=\"acl_bichain_list\">";
  echo html_acl_get_bichains($my_acl, $bichains);
  echo "</div>";

  print "<form method=\"post\" action=\"acls.php\" onsubmit=\"aclHandle(bichains_t)\" name=\"acls\" id=grrr>";

  echo '<input type="hidden" name="dndSort" value="" />';
  print "<input type=hidden name=acl value=\"$acl\"/>\n";
  print "<input type=hidden name=acl_nb value=".$my_acl->ID."/>";
  #print "<br/>\n";
  print "<table class=\"acl_edit\">";
  print "<tr><td class=\"rowtitle\">$gal_name</td>\n";
  print "<td colspan=3>";
  print "<input type=\"text\"  name=\"ch_name\" value=\"".$my_acl->name."\"/>";
  print "</td></tr>\n";

  print "<tr><td class=\"rowtitle\">$string_protocol</td>";
  print "<td colspan=3> <select name=protocol>\n";
  print "<option value=\"0\">--</option>";

  $array_protos=array();
  if (is_array($protocols->list_tab()))
  {
    foreach (($protocols->list_tab()) as $key=>$pro)
    {
      array_push($array_protos,$pro);
    }
  }
  sort($array_protos);

  foreach ($array_protos as $pro)
  {
    if (is_array($protocols->list_tab()))
    {
      foreach ($protocols->list_tab() as $key=>$foo)
      {
        if ($foo==$pro)
          break;
      }
    }
    if ($key!=""){
      print "<option value=\"$key\"";
      if ($pro == $proto->name)
        echo " selected";
      print ">".$pro."</option>";
    }
  }
  print " </select></td>"; /* end colspan protocol */
  print "</tr>\n";

 /*  print "<table class=\"acl_edit\"> */
  print "<tr><td class=\"rowtitle\">$string_period</td><td colspan=3> <select name=period>\n";
  print "<option value=\"0\">--</option>";

  $array_periods=array();
  foreach (($periods->list_tab()) as $key=>$pro)
  {
    array_push($array_periods,$pro);
  }
  sort($array_periods);

  foreach ($array_periods as $pro)
  {
    foreach ($periods->list_tab() as $key=>$foo)
    {
      if ($foo==$pro)
        break;
    }
    if ($key!=""){
      print "<option value=\"$key\"";
      if ($pro == $period->name)
        echo " selected";
      print ">".$pro."</option>";
    }
  }
  print " </select></td></tr>\n";

  #print "<tr><td class=\"rowtitle\">$string_application</td><td> <select name=application>\n";
  #print "<option value=\"0\">--</option>";

  if ($nufw_firewall)
  {
    print "<tr><td class=\"rowtitle\">$string_application</td><td colspan=3> <select name=application>\n";
    print "<option value=\"0\">--</option>";
    $array_applications=array();
    foreach (($applications->list_tab()) as $key=>$app)
    {
      array_push($array_applications,$app);
    }
    sort($array_applications);

    foreach ($array_applications as $app)
    {
      foreach ($applications->list_tab() as $key=>$foo)
      {
        if ($foo==$app)
          break;
      }
      if ($key!=""){
        print "<option value=\"$key\"";
        if ($app == $with->name)
          echo " selected";
	print ">".$app."</option>";
      }
    }
    print " </select></td></tr>\n";
  }



  print "<tr><td class=\"rowtitle\">$string_subject</td><td colspan=3> <select name=subject>\n";
  $array_subjs=array();
  foreach (($subjects->list_tab()) as $key=>$sub)
  {
    array_push($array_subjs,$sub);
  }
  sort($array_subjs);
  foreach ($array_subjs as $sub)
  {
    foreach ($subjects->list_tab() as $key=>$foo)
    {
      if ($foo==$sub)
        break;
    }
    if ($key!=""){
      print "<option value=\"$key\"";
      if ($sub == $from->name)
        echo " selected";
      print ">".$sub."</option>";
    }
  }
  print " </select></td></tr>\n";
  print "<tr><td class=\"rowtitle\">$string_ressource</td><td colspan=3> <select name=ressource>\n";


  $array_ress=array();
  foreach (($ressources->list_tab()) as $key=>$res)
  {
    array_push($array_ress,$res);
  }
  sort($array_ress);
  foreach ($array_ress as $res)
  {
    foreach ($ressources->list_tab() as $key=>$foo)
    {
      if ($foo==$res)
        break;
    }
    if ($key!=""){
      print "<option value=\"$key\"";
      if ($res == $to->name)
        echo " selected";
      print ">".$res."</option>";
    }
  }
  print "</select></td></tr>\n";
  print "<tr><td class=\"rowtitle\">$string_decision</td><td colspan=3> <select name=decision>\n";
  foreach (possible_values('acl','decision') as $possible)
  {
    print " <option";
    if ($possible==$my_acl->decision) echo " selected";
    print ">$possible</option>";
  }
  print "</select> </td></tr>";
  print "<tr><td class=\"rowtitle\">$string_modified</td><td colspan=3>".$my_acl->modified."</td></tr>";


  print "<tr><td class=\"rowtitle\">$string_group</td><td> <select name=group";
      /*print " onChange=\"griser_gren();\">\n";*/
      print " onChange=\"change_group_value();\">\n";
#  print "<option value=\"0\">--</option>";

  $array_groups=array();
  foreach (($groups->list_tab()) as $key=>$app)
  {
    array_push($array_groups,$app);
  }
  sort($array_groups);

  $selected=0;
  foreach ($array_groups as $grp)
  {
    foreach ($groups->list_tab() as $key=>$foo)
    {
      if ($foo==$grp)
        break;
    }
    if ($key!=""){
      print "<option value=\"$key\"";
      if ($grp == $group->name)
      {
        echo " selected";
        $selected=$group->enabled;
      }
      #print "onFocus=\"griser_gren();\" onChange=\"griser_gren();\"";
      print ">".$grp."</option>";
    }
  }
  ?>
  </select></td><td>
  <?php
  print $mess_enabled;
  ?>

  <input type="checkbox" name="gr_enabled"
  <?php
  if ($selected == 1)
    print " checked";
  print ">";

  ?>
  </td></tr>


  <?php





  print "</table>";
  print "<table class=acl_edit><tr><td class=rowtitle>$string_comment</td><td>";
  print "<textarea name=comment cols=29>";
  print $my_acl->comment;
  print "</textarea>";
  print "</td></tr></table>\n";
  if (isset($bichain_label) && $bichain_label != ''){
    print '<input type="hidden" name="bichain" value="'.$bichain_label.'"/>';
  }
  if (isset($chain_from) && $chain_from != ''){
    print '<input type="hidden" name="chainfrom" value="'.$chain_from.'"/>';
  }
  if (isset($chain_to) && $chain_to != ''){
    print '<input type="hidden" name="chainto" value="'.$chain_to.'"/>';
  }
  print "<input type=\"submit\"  value=\"$gal_button_apply\" class=\"button\" />";
  echo '<input type="hidden" name="dndSort" value="" />';
  print "</form>\n";
  print "<form action=\"acls.php\" method=\"post\" onsubmit=\"return ask_user_acl()\">";
  print "<input type=hidden name=delete value=$acl><input type=submit value=\"$mess_index_button_delete\" class=\"button\" /></form>";
  print "</div>";
}else{
  ?>
<h3>Groups</h3>
<form action="acls.php" method=post>
<input type=hidden name=modify_groups value=1>
<table>
<?php
print "<tr id=groupmenu><td>ID</td><td>$mess_symbol</td><td>$mess_label</td><td>$mess_comment</td><td>$mess_enabled</td><td>$mess_index_button_delete</td></tr>\n";
  $groups=$expolicy->groups;
  $array_groups=array();
  foreach ($groups->list_tab() as $key=>$foo)
  {
    if($foo){
        array_push($array_groups,$key);
    }
  }
  sort($array_groups);

  foreach ($array_groups as $key)
  {
    $group=$groups->get_elt($key);
  #    $group = &$groups->get_elt_by_id($key);
  print "<tr>";
  print "<td><a href=\"acls.php?group=$key\">".$key."</a></td><td><a href=\"acls.php?group=$key\"><img src=\"images/".$key.".png\"></a></td>";
  print "<td><input style=\"width: 6em;\" type=text name=name".$key." value=\"".$group->name."\"/></td><td><input style=\"width: 10em;\"  type=text name=comment".$key." value=\"".$group->comment."\"></td>";
  print "<td><input type=checkbox name=enabled".$key." ";
      if ($group->enabled == 1)
        echo "checked";
      $v = '0';
      if($group->is_used == false){
          $v='1';
          $v_form_del = '<input type="checkbox" name="del_grp['.$group->ID.']"/>';
      }
      echo "></td>";
      echo "<td>$v_form_del</td></tr>\n";

    }
?>
</table>

<input type="submit">
</form>
  <?php
}
#print '<div id="panel_bichains" style="visibility:hidden">'."\n";
print '<div id="panel_bichains">'."\n";
print '<form></form>';
print_chains_dnd(get_chains($expolicy, $used_desc));
print_targets_inout();
echo '<input type="submit" onclick="ajax_all_acls();" value="Valider">';
print "</div>\n";
end_content_detail();
?>

<?php
require_once ("include/footer.php");
?>
