<?php
#
# Copyright(C) 2004-2007 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#            Jean Gillaux <jean@inl.fr>
#            Damien Boucard <damien.boucard AT inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

require_once("defs.php");
require_once("security.php");
require_once 'pear/Net/IPv4.php';
require_once('netmask_list.php');
require_once ("config.php");
require_once ("messages.php");

function getmicrotime(){
    list($usec, $sec) = explode(" ",microtime());
        return ((float)$usec + (float)$sec);
}

if (version_compare(PHP_VERSION,'5','>=') && !extension_loaded("domxml"))
   require_once('domxml-php4-to-php5.php');

#Do not change this unless you know what you are doing!
$xml_nuface_version="1.0";

# string that represents the firewall in bichain
# ex: LOCAL-DMZ => output from DMZ
#$fw_chain = "LOCAL";

function print_pre($r) {
  print '<pre>';
  print_r($r);
  print '</pre>';
}

class elt {
    var $datas;
    function display($scope='one',$base=null) {
        if (($this->datas['type'] == 'link') and ($base and ($scope=='all'))){
            $base->display_elt($this->datas['linkid'],$scope,$base);
        } else {
            foreach($this->datas as $key=>$data){
                echo "$key : ".$data." ";
            }
        }
        echo "<br>";
    }
    function xmldump($xml,$curelt){
        $node=$xml->create_element( 'elt' );
        foreach($this->datas as $key=>$data){
          if (($data != '--') and ($data != '') and ($key!='invalid'))
                $node->set_attribute($key,$data);
        }
        $curelt->append_child($node);
    }
    function express($base=null) {
        $result=array();
        if (($this->datas['type'] == 'link')){
            $base->express_elt($this->datas['linkid'],'all',$base);
        } else {
            foreach($this->datas as $key=>$data){
                $result[$key]=$data;
            }
        }
        return($result);
    }
    function elt($data,$type='xml',$id=0){
      if ($type == 'xml')
      {
        $struct=$data->attributes();
        foreach($struct as $attr){
            $this->datas[$attr->name()]=$attr->value();
        }
      }else{
        if ($id==0){
          echo "Must be passed a valid ID!";
          return(-1);
        }
        $data["ID"]=$id;
        $this->datas=$data;
      }
    }
    function get_id(){
      return $this->datas["ID"];
    }
#    function list_tab()
#    {
#        foreach ($this->elts as $elt){
#          if ($elt->name!=''){
#            $result{$elt->ID} = ($elt->name);
#          }else{
#            $result{$elt->ID} = $elt->ID;
#          }
#        }
#      return $result;
#    }
    function get_obj()
    {
      $result=array();
      foreach ($this->datas as $key=>$obj)
      {
        $result{$key}=$obj;
      }
      return $result;
    }
}

#class ipv4_elt extends elt {
#    var $net;
#    var $dport;
#}

class set {
    var $elts;
}

class obj_set extends set {
    function display($scope='one'){
        foreach ($this->elts as $key=>$elt){
            printf("%d : ",$key);
            $elt->display($scope,$this);
            echo "<br>";
        }
    }
    function get_max_order($from=-2,$to=-2){
      if (($from == -2) or ($to == -2))
      {
        return -1;
      }
      $max=0;
      if (isset($this->elts))
      {
        foreach (($this->elts) as $elts){
          $local = $elts->get_max_elt_order($from,$to);
          if ($local>$max)
            $max = $local;
        }
      }
      return($max);
    }

    function get_max_order_id(){
      $max=0;
      if (isset($this->elts))
      {
        foreach (($this->elts) as $elts){
          $local = $elts->get_max_elt_order_id();
          if ($local>$max)
            $max = $local;
        }
      }
      return($max);
    }


    function xmldump($xml,$curelt){
        # TODO : use a DTD to do that ?
         $tagname = preg_replace('/s$/','', $curelt->tagname);
         if (isset($this->elts))
         foreach ($this->elts as $key=>$elt){
               $node = $xml->create_element($tagname);
#               $node->set_attribute('linkid',$key);
               if(!isset($elt)){
                    continue;
               }
               $elt->xmldump($xml,$node);
               $curelt->append_child($node);
         }
    }

    function display_elt($elt,$scope="one"){
        $this->elts[$elt]->display($scope,$base=$this);
    }
    function express_elt($elt,$scope="one"){
        $this->elts[$elt]->express($scope,$base=$this);
    }
    function obj_set($hash=array()){
        $this->elts=$hash;
    }
    function &get_elt($elt){
        return $this->elts[$elt];
    }
    function &get_elt_by_id($id){
        if (is_array($this->elts))
        {
	  foreach ($this->elts as $index => $elt){
		if ($elt->ID == $id){
			return $this->elts[$index];
		}
	  }
        }
	return null;
    }
    function replace_elt($index,$elt){
        unset ($this->elts[$index]);
        $this->elts[$index]=$elt;
    }
    function del_elt($index){
        unset ($this->elts[$index]);
    }
    function add_elt($elt,$id=-1){
      if ($id==-1)
      {
        $this->elts[$elt->get_id()]=$elt;
      }else{
        $this->elts[$id]=$elt;
      }
    }
    function get_max_elt_id(){
      $max=0;
      if (!isset($this->elts))
        return(0);
      foreach (($this->elts) as $elts){
        $local = $elts->get_max_elt_id();
        if ($local>$max)
          $max = $local;
      }
      return $max;
    }
    function new_elt_id(){
      return $this->get_max_elt_id() + 1;
    }
    function get_max_id(){
      $max=0;
      if (isset($this->elts))
        foreach (($this->elts) as $elts){
          $local=$elts->get_id();
          if ($local>$max)
            $max=$local;
        }
      return $max;
    }
    function new_id(){
      return($this->get_max_id()+1);
    }
    function new_lower_id(){
      $max=$this->get_max_id();
      $seen=array();
      foreach (($this->elts) as $elts)
      {
        $seen[$elts->get_id()]=1;
      }
      for ($i=1; $i<=$max+1; $i++)
      {
        if ($seen[$i]!=1)
          return $i;
      }
      return ($max+1);
    }
    function list_tab()
    {
      $result=array();
      if (isset($this->elts))
        foreach ($this->elts as $elt){
          if ($elt->name!=''){
            $result{$elt->ID} = ($elt->name);
          }else{
            $result{$elt->ID} = $elt->ID;
          }
        }
      return $result;
    }
    function ordered_list_tab()
    {
      $result=array();
      $ids=array();
      if (isset($this->elts))
      	foreach ($this->elts as $elt){
        	array_push($ids,$elt->ID);
      	}
      sort($ids);

      foreach ($ids as $id){
        foreach ($this->elts as $elt){
          if ($id == $elt->ID){
            if ($elt->name!=''){
              $result{$elt->ID} = ($elt->name);
            }else{
              $result{$elt->ID} = $elt->ID;
            }
          }
        }
      }
      return $result;
    }
    function nb_obj(){
      $result=0;
      foreach ($this->elts as $elt){
        $result++;
      }
      return($result);
    }

    function reorder(){
        $i=1;
        $clone = new obj_set(array());
        foreach($this->elts as $id_t =>$elt){
           $elt->ID = $i;
           $clone->add_elt($elt);
           $i++;
        }
        return $clone;
    }
}

class elt_set extends set {
    var $name;
    var $operator;
    var $ID;
    function display($scope='one',$base=null) {
        echo $this->name."<br>";
        echo "Logical op: ".$this->operator."<br>";
        foreach ($this->elts as $key=>$elt){
            echo "$key : ";
            $elt->display($scope,$base);
        }
    }
    function xmldump($xml,$node){
        $node->set_attribute('name',$this->name);
        if ((isset($this->operator)) and ($this->operator!=''))
        {
          $node->set_attribute('op',$this->operator);
        }
        if ((isset($this->defaultaction)) and ($this->defaultaction!='--') and ($this->defaultaction!=''))
        {
          $node->set_attribute('defaultaction',$this->defaultaction);
        }
        if (isset($this->defaultprefix) and ($this->defaultprefix!=''))
        {
          $node->set_attribute('defaultprefix',$this->defaultprefix);
        }
        $node->set_attribute('ID',$this->ID);
        foreach ($this->elts as $elt){
                $elt->xmldump($xml,$node);
        }
    }
    function elt_set($ress,$type='xml',$id=0){
      if ($type != 'xml')
      {
        if (is_object($ress)) {
            // PHP5 compatibility conversion
            $ress = (Array)$ress;
        }
        if ($id==0){
#          print_r($ress);
          echo "Must be passed a valid ID!";
          return(-1);
        }
        $this->ID=$id;
        if (isset($ress['operator']))
        {
          $this->operator=$ress['operator'];
        }
        if ((isset($ress['defaultaction'])) and ($ress['defaultaction']!='--') and ($ress['defaultaction']!=''))
        {
          $this->defaultaction=$ress['defaultaction'];
        }
        if (isset($ress['defaultprefix']) and ($ress['defaultprefix']!=''))
        {
          $this->defaultprefix=$ress['defaultprefix'];
        }
        $this->name=$ress['name'];
      }else{
        $op=$ress->get_attribute('op');
        if (isset($op))
        {
          $this->operator=$ress->get_attribute('op');
        }
        $dfltac=$ress->get_attribute('defaultaction');
        if ((isset($dfltac)) and ($dfltac!='--') and ($dfltac!=''))
        {
          $this->defaultaction=$ress->get_attribute('defaultaction');
        }
        $dfltpre=$ress->get_attribute('defaultprefix');
        if (isset($dfltpre) and ($dfltpre!=''))
        {
          $this->defaultprefix=$ress->get_attribute('defaultprefix');
        }
        $this->name=$ress->get_attribute('name');
        $this->ID=$ress->get_attribute('ID');
      }
    }
    function add_elt($elt){
        $this->elts[$elt->get_id()]=$elt;
    }
    function del_elt($index){
        #array_splice($this->elts,$index,1);
        unset ($this->elts[$index]);
    }
    function modify_param($param,$value){
        if ($param == 'ID'){
          return(-1);
        }
        if (($param=='name') or ($param=='operator') or ($param=='comment') or ($param=='modified') or ($param=='defaultaction') or ($param=='defaultprefix')){
          $this->$param=$value;
          return(0);
        }
        return(-1);
    }

    function &get_elt($elt){
        return $this->elts[$elt];
    }
    function get_id(){
      return($this->ID);
    }
    function get_max_elt_id(){
        $max=0;
        foreach ($this->elts as $elt){
            $local=$elt->get_id();
            if ($local>$max)
              $max=$local;
        }
        return $max;
    }
    function list_tab()
    {
        foreach ($this->elts as $elt){
          if ($elt->datas['name']!=''){
            $result{$elt->datas['ID']} = ($elt->datas['name']);
          }else{
            $result{$elt->datas['ID']} = $elt->datas['ID'];
          }
        }
      return $result;
    }
    function get_obj()
    {
      foreach ($this as $key=>$obj)
      {
#Skip elts, that contains stuff from subelements
        if ($key=='elts')
          continue;
        $result{$key}=$obj;
      }
      return $result;
    }
}

class ressource extends elt_set {
    function ressource($ress,$type='xml',$id=0){
        $this->elts=array();
        parent::elt_set($ress,$type,$id);
        if ($type=='xml'){
          foreach($ress->get_elements_by_tagname("elt") as $resselt){
            $selt=new elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
        }
# TODO add some checking
    }
    function express($ress){
        foreach($ress->get_elements_by_tagname("elt") as $resselt){
          $result=$resselt->express;
        }
    }
}


class network_set extends elt_set{
    function network_set($ress,$type='xml',$id=0){
      $this->elts=array();
      parent::elt_set($ress,$type,$id);
        if ($type=='xml'){
          foreach($ress->get_elements_by_tagname("nets") as $resselt){
            $selt=new elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
          }
        }
    }
#    function get_id(){
#      return($this->ID);
#    }
}
class connection extends elt{
    function connection($ress,$type='xml',$id=0){
      $this->elts=array();
      parent::elt($ress,$type,$id);
        if ($type=='xml'){
          foreach($ress->get_elements_by_tagname("connection") as $resselt){
            $selt=new elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
          }
        }
    }
    function xmldump($xml,$curelt){
        $node=$xml->create_element( 'net' );
        foreach($this->datas as $key=>$data){
          if (($data != '--') and ($data != ''))
                $node->set_attribute($key,$data);
        }
        $curelt->append_child($node);
    }
}

class network extends elt{
    function network($ress,$type='xml',$id=0){
      $this->elts=array();
      parent::elt($ress,$type,$id);
#      print_r($this);
      if (isset($this->datas['ID']))
      {
        $this->datas['id']=$this->datas['ID'];
        unset($this->datas['ID']);
      }
      #print_r($this);
        if ($type=='xml'){
          foreach($ress->get_elements_by_tagname("net") as $resselt){
            print_r($resselt);
            $selt=new elt($resselt);
            #print "ICI";
            #print_r($selt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
          }
        }
    }
    function xmldump($xml,$curelt){
        $node=$xml->create_element( 'net' );
        foreach($this->datas as $key=>$data){
          if (($data != '--') and ($data != ''))
                $node->set_attribute($key,$data);
        }
        $curelt->append_child($node);
    }
}

class address extends elt{
    function address($ress,$type='xml',$id=0){
      $this->elts=array();
      parent::elt($ress,$type,$id);
      if (isset($this->datas['ID']))
      {
        $this->datas['id']=$this->datas['ID'];
        unset($this->datas['ID']);
      }
        if ($type=='xml'){
          foreach($ress->get_elements_by_tagname("addr") as $resselt){
            $selt=new elt($resselt);
            #print "ICI";
            #print_r($selt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
          }
        }
    }
    function xmldump($xml,$curelt){
        $node=$xml->create_element( 'addr' );
        foreach($this->datas as $key=>$data){
          if (($data != '--') and ($data != ''))
                $node->set_attribute($key,$data);
        }
        $curelt->append_child($node);
    }
}

class desc extends elt_set{
    function desc($ress,$type='xml',$id=0){
        $this->networks = new obj_set();
        $this->addresses = new obj_set();
        parent::elt_set($ress,$type,$id);
        if ($type=='xml')
        {
          foreach($ress->get_elements_by_tagname("net") as $resselt){
            $selt=new network($resselt);
            $id=$resselt->get_attribute('ID');
            if ((!isset($id)) or ($id==""))
            {
              $id=$resselt->get_attribute('id');
            }
            $this->networks->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
          foreach($ress->get_elements_by_tagname("addr") as $resselt){
            $selt=new address($resselt);
            $id=$resselt->get_attribute('ID');
            if ((!isset($id)) or ($id==""))
            {
              $id=$resselt->get_attribute('id');
            }
            $this->addresses->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
        }
        if ($type=='file')
        {
          if (!$dom = domxml_open_file($ress)) {
            //echo "Error while parsing the document\n";
            //exit;
            unset($this);
            return;
          }
          $root = $dom->document_element();
#          print_r($root);
#          $network = $root->get_elements_by_tagname("network");
#          $network=$network[0];
          $nets = $root->get_elements_by_tagname("nets");
#          print_r($nets);
          $nets=$nets[0];
          $network_list=$nets->get_elements_by_tagname("net");
          foreach ($network_list as $mynet){
            $newnet=new network($mynet);
            #UGLY HACK to get the default route, if exists
            $connection_list=$mynet->get_elements_by_tagname("connection");
            foreach ($connection_list as $myconn)
            {
              $newconn=new connection($myconn);
              if (isset($newconn->datas['dftgateway']))
              {
                $newnet->datas['dftroute']=1;
              }
            }
            #END UGLY HACK
            #print_r($newnet);
            $id=$mynet->get_attribute("id");
            if (!isset($id) or ($id==""))
            {
              $id=$mynet->get_attribute("ID");
            }
            $hash_net[$id]=$newnet;
          }
          $this->networks=new obj_set($hash_net);
#Also need to parse local firewall addresses !
#          $fws = $root->get_elements_by_tagname("fws");
#          $fws=$fws[0];
          $address_list=$root->get_elements_by_tagname("address");
          $hash_addr = Array();
          foreach ($address_list as $myaddress){
            $newaddress=new address($myaddress);

            #print_r($newnet);
            $id=$myaddress->get_attribute("id");
            if (!isset($id) or ($id==""))
            {
              $id=$myaddress->get_attribute("ID");
            }
            while (isset($hash_addr[$id]))
            {
              $id++;
            }
            $hash_addr[$id]=$newaddress;
          }
          $this->addresses=new obj_set($hash_addr);
        }
    }

    function xmldump($xml,$node){
        $node->set_attribute('ID',$this->ID);
        $descnode = $xml->create_element("networks");
        $node->append_child($descnode);
        $descsortsobjets=$this->networks->elts;
        foreach($descsortsobjets as $descsortsobjet){
            /*$descsortsobjet = $descsortsobjet[$used_desc];*/
            $descsortsobjet->xmldump($xml,$descnode);
        }
        $descnode = $xml->create_element("addresses");
        $node->append_child($descnode);
        $descsortsobjets=$this->addresses->elts;
        foreach($descsortsobjets as $descsortsobjet){
            /*$descsortsobjet = $descsortsobjet[$used_desc];*/
            $descsortsobjet->xmldump($xml,$descnode);
        }

    }


#    function new_id()
#    {
#      return count($this->elts)+1;
#    }

    # get network by its name
    function get_net_by_name($name){
        #var_dump($this->elts);
        #if ($name == 'LOCAL')
        #{
        #  $local_net = array ('name'=>'LOCAL',
        #                      'id'=>'-1');
        #  $res = new network($local_net);
        #  print_r($res);
        #}
        #print_pre($this->networks->elts);
        foreach($this->networks->elts as $network){
          #print_pre($network);
            $network_data = $network->datas;
            if ($network_data['name'] == $name){
                return $network;
            }
        }
        return null;
    }
}


class subject extends elt_set {
    function subject($ress,$type='xml',$id=0){
        $this->elts=array();
        parent::elt_set($ress,$type,$id);
        if ($type=='xml')
        {
          foreach($ress->get_elements_by_tagname("elt") as $resselt){
            $selt=new elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
        }
# TODO add some checking
    }
}

class period extends elt_set {
    function period($ress,$type='xml',$id=0){
        $this->elts=array();
        parent::elt_set($ress,$type,$id);
        if ($type=='xml')
        {
          foreach($ress->get_elements_by_tagname("elt") as $resselt){
            $selt=new elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
        }
# TODO add some checking
    }
}

class application extends elt_set {
    function application($ress,$type='xml',$id=0){
        $this->elts=array();
        parent::elt_set($ress,$type,$id);
        if ($type=='xml')
        {
          foreach($ress->get_elements_by_tagname("elt") as $resselt){
            $selt=new elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
        }
# TODO add some checking
    }
}


class protocol extends elt_set {
    function protocol($ress,$type='xml',$id=0){
        $this->elts=array();
        parent::elt_set($ress,$type,$id);
        if ($type=='xml')
        {
          foreach($ress->get_elements_by_tagname("elt") as $resselt){
            $selt=new elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
        }
# TODO add some checking
    }

    function xmldump($xml,$node){
        $node->set_attribute('name',$this->name);
#        $node->set_attribute('op',$this->operator);
        $node->set_attribute('ID',$this->ID);
        foreach ($this->elts as $elt){
                $elt->xmldump($xml,$node);
        }
    }
}

class l7rule extends elt_set {
    function l7rule($ress,$type='xml',$id=0){
        $this->elts=array();
        parent::elt_set($ress,$type,$id);
        if ($type=='xml')
        {
          foreach($ress->get_elements_by_tagname("elt") as $resselt){
            $selt=new elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
        }
# TODO add some checking
    }
}

class order_elt extends elt {
    var $from;
    var $to;
    var $order;
    var $ID;
    function xmldump($xml,$curelt){
        $node=$xml->create_element( 'elt' );
        if (is_array($this->datas))
        {
          foreach($this->datas as $key=>$data){
            if (($data != '--') and ($data != '') and ($key!='invalid'))
                $node->set_attribute($key,$data);
          }
        }
        $curelt->append_child($node);

        $node->set_attribute('from',$this->from);
        $node->set_attribute('to',$this->to);
        $node->set_attribute('order',$this->order);
        $node->set_attribute('ID',$this->ID);
        if (is_array($this->elts))
        {
          foreach ($this->elts as $elt){
            $elt->xmldump($xml,$node);
          }
        }
    }
    function order_elt($ress,$type='xml',$id=0){
      if ($type != 'xml')
      {
        if ($id==0){
#          print_r($ress);
          echo "Must be passed a valid ID!";
          return(-1);
        }
        $this->ID=$id;
        $this->order=$ress['order'];
        $this->from=$ress['from'];
        $this->to=$ress['to'];
      }else{
        $this->ID=$ress->get_attribute('ID');
        $this->from=$ress->get_attribute('from');
        $this->to=$ress->get_attribute('to');
        $this->order=$ress->get_attribute('order');
      }
    }
    function add_elt($elt){
        $this->elts[$elt->get_id()]=$elt;
    }
    function del_elt($index){
        #array_splice($this->elts,$index,1);
        unset ($this->elts[$index]);
    }
    function modify_param($param,$value){
        if ($param == 'ID'){
          return(-1);
        }
        if (($param=='from') or ($param=='to') or ($param=='order')){
          $this->$param=$value;
          return(0);
        }
        return(-1);
    }

    function &get_elt($elt){
        return $this->elts[$elt];
    }
    function get_id(){
      return($this->ID);
    }
    function get_max_elt_id(){
        $max=0;
        foreach ($this->elts as $elt){
            $local=$elt->get_id();
            if ($local>$max)
              $max=$local;
        }
        return $max;
    }
#    function list_tab()
#    {
#        foreach ($this->elts as $elt){
#          if ($elt->datas['name']!=''){
#            $result{$elt->datas['ID']} = ($elt->datas['name']);
#          }else{
#            $result{$elt->datas['ID']} = $elt->datas['ID'];
#          }
#        }
#      return $result;
#    }
    function get_obj()
    {
      foreach ($this as $key=>$obj)
      {
#Skip elts, that contains stuff from subelements
        if ($key=='elts')
          continue;
        $result{$key}=$obj;
      }
      return $result;
    }
}

class descsort extends set {
  var $ID;
    function descsort($ress,$type='xml',$id=0){
        $this->elts=array();
        if ($type != 'xml')
        {
          if ($id==0){
#          print_r($ress);
            echo "Must be passed a valid ID!";
            return(-1);
          }
          $this->ID=$id;
          $this->elts=$ress['elts'];
        } else {
          $this->ID=$ress->get_attribute('ID');
          foreach($ress->get_elements_by_tagname("elt") as $resselt){
            $selt=new order_elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
        }
# TODO add some checking
    }
    function xmldump($xml,$node){
        $descsort_n = $xml->create_element('descsort');
        $descsort_n->set_attribute('ID',$this->ID);
        $node->append_child($descsort_n);
        //$node->set_attribute('ID',$this->ID);
        foreach ($this->elts as $elt){
                $elt->xmldump($xml,$descsort_n);
        }
    }
    function get_max_id()
    {
      $max=0;
      foreach ($this->elts as $elt)
      {
        if ($elt->ID>$max)
          $max=$elt->ID;
      }
      return($max);
    }

    function get_order($from,$to)
    {
      $elt = $this->get_elt($from, $to);
      if($elt == null){
          return 0;
      }
      return $elt->order;
    }
    function get_elt($from, $to)
    {
      if (is_array($this->elts))
      {
        foreach ($this->elts as $elt)
        {
          if (($elt->from == $from) and ($elt->to == $to))
            return($elt);
        }
        return(null);
      }
    }

}




class acl  {
  var $name;
  var $from;
  var $with;
  var $to;
  var $proto;
  var $ID;
  var $period;
  var $decision;
  var $modified;
  var $comment;
  var $group;
    function acl($ress,$type='xml',$id=0){
      if ($type != 'xml')
      {
        if ($id==0){
          echo "Must be passed a valid ID!";
          return(-1);
        }
        $this->ID=$id;
        $this->name=$ress['name'];
        $this->from=$ress['from'];
        if (($ress['period']!=0) and ($ress['period']!=''))
          $this->period=$ress['period'];
        if (($ress['with']!=0) and ($ress['with']!=''))
          $this->with=$ress['with'];
        if (($ress['proto']!=0) and ($ress['proto']!=''))
          $this->proto=$ress['proto'];
        $this->to=$ress['to'];
        $this->decision=$ress['decision'];
        $this->comment=$ress['comment'];
        $this->modified=$ress['modified'];
        $this->group=$ress['group'];
        if ((!isset($this->group)) or ($this->group == ''))
          $this->group=1;
#        defined ($this->group) or $this->group=1;
        #$this->descsorts=new obj_set();
        $this->descsorts=$ress['descsorts'];
      }else{
        $this->name=$ress->get_attribute('name');
        $this->from=$ress->get_attribute('from');
        if (($ress->get_attribute('period')) and ($ress->get_attribute('period')!=''))
          $this->period=$ress->get_attribute('period');
        $this->to=$ress->get_attribute('to');
        if (($ress->get_attribute('with')) and ($ress->get_attribute('with')!=''))
          $this->with=$ress->get_attribute('with');
        if (($ress->get_attribute('proto')) and ($ress->get_attribute('proto')!=''))
          $this->proto=$ress->get_attribute('proto');
        $this->ID=$ress->get_attribute('ID');
        $this->decision=$ress->get_attribute('decision');
        $this->modified=$ress->get_attribute('modified');
        $this->comment=$ress->get_attribute('comment');
        $this->group=$ress->get_attribute('group');
        if ((!isset($this->group)) or ($this->group == ''))
          $this->group=1;
#        defined ($this->group) or $this->group=1;

        $descsorts = $ress->get_elements_by_tagname("descsorts");
        $descsorts = $descsorts[0];
        /* iter on ressource */
        $hash_ds=array();
        if (isset($descsorts))
        {
          $descsort_list=$descsorts->get_elements_by_tagname("descsort");
          foreach ($descsort_list as $ds){
            $newds=new descsort($ds);
            $id=$ds->get_attribute("ID");
            $hash_ds[$id]=$newds;
          }
        }
          $this->descsorts=new obj_set($hash_ds);
      }
    }

    function xmldump($xml,$node){
        $used_desc = $_SESSION['used_desc'];
        $node->set_attribute('name',$this->name);
        $node->set_attribute('from',$this->from);
        $node->set_attribute('to',$this->to);
        if ($this->with!='')
          $node->set_attribute('with',$this->with);
        if ($this->proto!='')
          $node->set_attribute('proto',$this->proto);
        if ($this->period!='')
          $node->set_attribute('period',$this->period);
        $node->set_attribute('ID',$this->ID);
        $node->set_attribute('decision',$this->decision);
        $node->set_attribute('comment',$this->comment);
        $node->set_attribute('modified',$this->modified);
        $node->set_attribute('group',$this->group);
        $descnode = $xml->create_element("descsorts");
        $node->append_child($descnode);
        $descsortsobjets=$this->descsorts->elts;
        if (is_array($descsortsobjets))
        {
          foreach($descsortsobjets as $descsortsobjet){
            /*$descsortsobjet = $descsortsobjet[$used_desc];*/
            $descsortsobjet->xmldump($xml,$descnode);
          }
        }

    }

    function display($scope='one',$base=null) {
        echo "$this->name : from $this->from with $this->with to $this->to protocol $this->proto at $this->period decision $this->decision<br>";
    }
    function new_id(){
      return($this->get_max_id()+1);
    }
    function get_id(){
      return($this->ID);
    }
    function get_max_elt_order($from=-2,$to=-2){
        $max=0;
        if (($from == -2) or ($to == -2))
        {
          return(-1);
        }
        if (is_array($this->descsorts->elts))
        {
          foreach ($this->descsorts->elts as $elt){
            if(isset($elt) && $elt != null && $elt->elts != null){
              $local=$elt->get_order($from,$to);
              if ($local>$max)
                $max=$local;
            }
          }
        }
        return $max;
    }

    function get_max_elt_order_id(){
        $max=0;
        if (is_array($this->descsorts->elts))
        {
          foreach ($this->descsorts->elts as $elt){
              if(isset($elt) && $elt != null && $elt->elts != null){
              $local=$elt->get_max_id();
              if ($local>$max)
                $max=$local;
              }
          }
        }
        return $max;
    }

    #
    # get acl order in desc referenced by desc_id
    # for bichain referenced by (from,to)
    function get_order($desc_id, $from, $to){
        $order = 0;
#        print "acl->get_order: $desc_id, $from, $to\n";
        if (is_array($this->descsorts->elts))
        {
          foreach ($this->descsorts->elts as $elt){
            #print "descsort elt ID".$elt->ID."\n";
#            print_r($elt);
            if ($elt->ID == $desc_id){
                #print "elt ID = $desc_id\n";
                $order = $elt->get_order($from, $to);
                if($order != 0){
                    return $order;
                }
            }
          }
        }
        return $order;
    }

    #
    # set acl order in desc referenced by desc_id
    # for bichain referenced by (from,to)
    # with order
    function set_order($desc_id, $from, $to, $order, $new_id){
        if ($this->descsorts->elts == null){
            $this->descsorts->elts = array();
        }
        if (!isset($this->descsorts->elts[$desc_id]) || $this->descsorts->elts[$desc_id] == null || $this->descsorts->elts[$desc_id]->elts == null )
        {
          $newdesc = new descsort(array('elts' => null),'data',$desc_id);
          $this->descsorts->elts[$desc_id] = $newdesc;
        }
        #print_r($this->descsorts->elts);
        foreach ($this->descsorts->elts as $elt){
            #print "descsort elt ID".$elt->ID."\n";
            if ($elt->ID == $desc_id){
                $elt_order = $elt->get_elt($from, $to);
                if (!isset($elt_order))
                {
                  $creator['order']=$order;
                  $creator['from']=$from;
                  $creator['to']=$to;
                  $new_order = new order_elt($creator,'data',$new_id);
                  $this->descsorts->elts[$desc_id]->elts[$new_id] = $new_order;
                }
            }
          }
        foreach ($this->descsorts->elts as $elt){
            #print "descsort elt ID".$elt->ID."\n";
            if ($elt->ID == $desc_id){
                $elt_order = $elt->get_elt($from, $to);
                $elt_order->modify_param('order', $order);
                #print "elt order modifi�"; print_r($elt_order);
                $descsorts = $this->descsorts->elts;
                #print "this->descsorts->elts:"; print_r($descsorts);
                $descsort_id = $descsorts[$desc_id];
                #print "this->descsorts->elts[elt->ID]:"; print_r($descsort_id);print "end1";
                $descsort_id->elts[$elt_order->ID] = $elt_order;
                #print "descsort_id modifi�"; print_r($descsort_id);print "end";
                $this->descsorts->elts[$desc_id] = $descsort_id;
                #print_r($this->descsorts->elts[$desc_id]);
                #print_r($this->descsorts->elts);
                return;
            }
        }
    }

    function cloneobj(){
      $t=array();
      $t['name']=$this->name;
      $t['proto']=$this->proto;
      $t['period']=$this->period;
      $t['from']=$this->from;
      $t['with']=$this->with;
      $t['to']=$this->to;
      $t['ID']=$this->ID;
      $t['decision']=$this->decision;
      $t['modified']=$this->modified;
      $t['comment']=$this->comment;
      $t['group']=$this->group;
      $t['descsorts'] = $this->descsorts;
#      defined ($t['group']) or $t['group'] = 1;
      return new acl($t,$type='toto',$id=$t['ID']);
    }
}

class nat {
  var $name;
  var $srcnet;
  var $dstnet;
  var $proto;
  var $ID;
  var $sport;
  var $dport;
  var $icmptype;
  var $rewritetoaddr;
  var $rewritetoport;
  var $group;
    function nat($ress,$type='xml',$id=0){
      if ($type != 'xml')
      {
        if ($id==0){
          echo "Must be passed a valid ID!";
          return(-1);
        }
        $this->ID=$id;
        $this->name=$ress['name'];
        if (($ress['srcnet']!=0) and ($ress['srcnet']!=''))
          $this->srcnet=$ress['srcnet'];
        if (!preg_match('/^$/',$ress['dstnet']))
          $this->dstnet=$ress['dstnet'];
        $this->proto=$ress['proto'];
        if (($ress['sport']!=0) and ($ress['sport']!=''))
          $this->sport=$ress['sport'];
        if (($ress['dport']!=0) and ($ress['dport']!=''))
          $this->dport=$ress['dport'];
        $this->icmptype=$ress['icmptype'];
        if (($ress['rewritetoaddr']!=0) and ($ress['rewritetoaddr']!=''))
          $this->rewritetoaddr=$ress['rewritetoaddr'];
        if (($ress['rewritetoport']!=0) and ($ress['rewritetoport']!=''))
          $this->rewritetoport=$ress['rewritetoport'];
        $this->comment=$ress['comment'];
        $this->modified=$ress['modified'];
        $this->group=$ress['group'];
#        defined ($this->group) or $this->group=1;
      }else{
        $this->name=$ress->get_attribute('name');
        if (($ress->get_attribute('srcnet')) and ($ress->get_attribute('srcnet')!=''))
          $this->srcnet=$ress->get_attribute('srcnet');
        if (($ress->get_attribute('dstnet')) and ($ress->get_attribute('dstnet')!=''))
          $this->dstnet=$ress->get_attribute('dstnet');
        if (($ress->get_attribute('proto')) and ($ress->get_attribute('proto')!=''))
          $this->proto=$ress->get_attribute('proto');
        if (($ress->get_attribute('sport')) and ($ress->get_attribute('sport')!=''))
          $this->sport=$ress->get_attribute('sport');
        if (($ress->get_attribute('dport')) and ($ress->get_attribute('dport')!=''))
          $this->dport=$ress->get_attribute('dport');
        if (($ress->get_attribute('icmptype')) and ($ress->get_attribute('icmptype')!=''))
          $this->icmptype=$ress->get_attribute('icmptype');
        $this->ID=$ress->get_attribute('ID');
        if (($ress->get_attribute('rewritetoaddr')) and ($ress->get_attribute('rewritetoaddr')!=''))
          $this->rewritetoaddr=$ress->get_attribute('rewritetoaddr');
        if (($ress->get_attribute('rewritetoport')) and ($ress->get_attribute('rewritetoport')!=''))
          $this->rewritetoport=$ress->get_attribute('rewritetoport');
        $this->modified=$ress->get_attribute('modified');
        $this->comment=$ress->get_attribute('comment');
        $this->group=$ress->get_attribute('group');
#        defined ($this->group) or $this->group=1;
      }
    }

    function del_elt($index){
        unset ($this);
    }

    function xmldump($xml,$node){
        $node->set_attribute('name',$this->name);
        if ($this->srcnet!='')
          $node->set_attribute('srcnet',$this->srcnet);
        if ($this->dstnet!='')
          $node->set_attribute('dstnet',$this->dstnet);
        if ($this->proto!='')
          $node->set_attribute('proto',$this->proto);
        if ($this->sport!='')
          $node->set_attribute('sport',$this->sport);
        if ($this->dport!='')
          $node->set_attribute('dport',$this->dport);
        if ($this->icmptype!='')
          $node->set_attribute('icmptype',$this->icmptype);
        if ($this->rewritetoaddr!='')
          $node->set_attribute('rewritetoaddr',$this->rewritetoaddr);
        if ($this->rewritetoport!='')
          $node->set_attribute('rewritetoport',$this->rewritetoport);
        $node->set_attribute('ID',$this->ID);
        $node->set_attribute('comment',$this->comment);
        $node->set_attribute('modified',$this->modified);
        $node->set_attribute('group',$this->group);
    }

    function display($scope='one',$base=null) {
        echo "$this->name : from $this->srcnet to $this->dstnet protocol $this->proto to $this->rewritetoaddr<br>";
    }
    function new_id(){
      return($this->get_max_id()+1);
    }
    function get_id(){
      return($this->ID);
    }
    function cloneobj(){
      $t=array();
      $t['name']=$this->name;
      $t['proto']=$this->proto;
      $t['srcnet']=$this->srcnet;
      $t['dstnet']=$this->dstnet;
      $t['sport']=$this->sport;
      $t['dport']=$this->dport;
      $t['icmptype']=$this->icmptype;
      $t['ID']=$this->ID;
      $t['rewritetoaddr']=$this->rewritetoaddr;
      $t['rewritetoport']=$this->rewritetoport;
      $t['group']=$this->group;
#      defined ($t['group']) or $t['group'] = 1;
      return new nat($t,$type='toto',$id=$t['ID']);
    }
}

class group {
  var $name;
  var $ID;
  var $enabled;
  var $comment;
    function group($ress,$type='xml',$id=0){
      if ($type != 'xml')
      {
        if ($id==0){
          echo "Must be passed a valid ID!";
          return(-1);
        }
        $this->ID=$id;
        $this->name=$ress['name'];
        $this->enabled=$ress['enabled'];
        $this->comment=$ress['comment'];
        $this->is_used = false;
        if ($ress['is_used'] != ''){
            $this->is_used = true;
        }
#        defined ($this->enabled) or $this->enabled = 1;
      }else{
        $this->name=$ress->get_attribute('name');
        $this->ID=$ress->get_attribute('ID');
        $this->enabled=$ress->get_attribute('enabled');
        $this->comment=$ress->get_attribute('comment');
        $this->is_used = false;
#        defined ($this->enabled) or $this->enabled = 1;
      }
    }
    function del_elt($index){
        unset ($this);
    }

    function xmldump($xml,$node){
        $node->set_attribute('name',$this->name);
        $node->set_attribute('ID',$this->ID);
        $node->set_attribute('comment',$this->comment);
        $node->set_attribute('enabled',$this->enabled);
    }
    function new_id(){
      return($this->get_max_id()+1);
    }
    function get_id(){
      return($this->ID);
    }
    function cloneobj(){
      $t=array();
      $t['name']=$this->name;
      $t['ID']=$this->ID;
      $t['group']=$this->group;
      $t['enabled']=$this->enabled;
      $t['comment']=$this->comment;
      $t['is_used']=$this->is_used;
#      defined($t['enabled']) or $t['enabled']=1;
      return new group($t,$type='toto',$id=$t['ID']);
    }
}


class policy extends elt {
    /* 3 hashs containing needed informations */
    var $ressources;
    var $subjects;
    var $periods;
    var $applications;
    var $protocols;
    var $l7rules;
    var $acls;
    var $snats;
    var $dnats;
    var $pnats;
    var $groups;
    var $descs;

    /* creator from xml file */
    function policy($file){
        if (!$dom = domxml_open_file($file)) {
            //echo "Error while parsing the document\n";
            //exit;
            unset($this);
            return;
        }
        $root = $dom->document_element();

        $descs = $root->get_elements_by_tagname("descs");
        $descs=$descs[0];
        /* iter on desc */
        $desc_list=$descs->get_elements_by_tagname("desc");
        $hash_desc = Array();
        foreach ($desc_list as $desc){
            $newdesc=new desc($desc);
            $id=$desc->get_attribute("ID");
            $hash_desc[$id]=$newdesc;
        }
        $this->descs=new obj_set($hash_desc);

        $periods = $root->get_elements_by_tagname("periods");
        $periods=$periods[0];
        /* iter on ressource */
        $period_list=$periods->get_elements_by_tagname("period");
        $hash_per = Array();
        foreach ($period_list as $per){
            $newper=new period($per);
            $id=$per->get_attribute("ID");
            $hash_per[$id]=$newper;
        }
        $this->periods=new obj_set($hash_per);
        /*print_r($this->periods);*/

        $ressources = $root->get_elements_by_tagname("ressources");
        $ressources=$ressources[0];
        /* iter on ressource */
        $ressource_list=$ressources->get_elements_by_tagname("ressource");
        $hash_ress = Array();
        foreach ($ressource_list as $ress){
            $newress=new ressource($ress);
            $id=$ress->get_attribute("ID");
            $hash_ress[$id]=$newress;
        }
        $this->ressources=new obj_set($hash_ress);

        $subjects = $root->get_elements_by_tagname("subjects");
        $subjects=$subjects[0];
        $subject_list=$subjects->get_elements_by_tagname("subject");
        $hash_sub = Array();
        foreach ($subject_list as $sub){
            $newsub=new subject($sub);
            $id=$sub->get_attribute("ID");
            $hash_sub[$id]=$newsub;
        }
        $this->subjects=new obj_set($hash_sub);

        $applications = $root->get_elements_by_tagname("applications");
        $applications=$applications[0];
        $application_list=$applications->get_elements_by_tagname("application");
        $hash_app = Array();
        foreach ($application_list as $app){
            $newapp=new application($app);
            $id=$app->get_attribute("ID");
            $hash_app[$id]=$newapp;
        }
        $this->applications=new obj_set($hash_app);

        $protocols = $root->get_elements_by_tagname("protocols");
        $protocols=$protocols[0];
        $protocol_list=$protocols->get_elements_by_tagname("protocol");
        if (is_array($protocol_list))
        {
          foreach ($protocol_list as $pro){
            $newprot=new protocol($pro);
            $id=$pro->get_attribute("ID");
            $hash_proto[$id]=$newprot;
          }
        }
        $this->protocols=new obj_set($hash_proto);

        $l7rules = $root->get_elements_by_tagname("l7rules");
        $l7rules=$l7rules[0];
        $l7rule_list=$l7rules->get_elements_by_tagname("l7rule");
        $hash_l7r = Array();
        foreach ($l7rule_list as $l7r){
            $newl7r=new l7rule($l7r);
            $id=$l7r->get_attribute("ID");
            $hash_l7r[$id]=$newl7r;
        }
        $this->l7rules=new obj_set($hash_l7r);

        $acls = $root->get_elements_by_tagname("acls");
        $acls=$acls[0];
        $acl_list=$acls->get_elements_by_tagname("acl");
        $hash_acls = Array();
        foreach ($acl_list as $sub){
            $newsub=new acl($sub);
            $id=$sub->get_attribute("ID");
            $hash_acls[$id]=$newsub;
        }
        $this->acls=new obj_set($hash_acls);

        $snats = $root->get_elements_by_tagname("snats");
        $snats=$snats[0];
        $snat_list=$snats->get_elements_by_tagname("snat");
        $hash_snats = Array();
        foreach ($snat_list as $sub){
            $newsub=new nat($sub);
            $id=$sub->get_attribute("ID");
            $hash_snats[$id]=$newsub;
        }
        $this->snats=new obj_set($hash_snats);

        $dnats = $root->get_elements_by_tagname("dnats");
        $dnats=$dnats[0];
        $dnat_list=$dnats->get_elements_by_tagname("dnat");
        $hash_dnats = Array();
        foreach ($dnat_list as $sub){
            $newsub=new nat($sub);
            $id=$sub->get_attribute("ID");
            $hash_dnats[$id]=$newsub;
        }
        $this->dnats=new obj_set($hash_dnats);

        $pnats = $root->get_elements_by_tagname("pnats");
        $pnats=$pnats[0];
        $pnat_list=$pnats->get_elements_by_tagname("pnat");
        $hash_pnats = Array();
        foreach ($pnat_list as $sub){
            $newsub=new nat($sub);
            $id=$sub->get_attribute("ID");
            $hash_pnats[$id]=$newsub;
        }
        $this->pnats=new obj_set($hash_pnats);

        $groups = $root->get_elements_by_tagname("groups");
        $groups=$groups[0];
        $group_list=$groups->get_elements_by_tagname("group");
        $hash_groups = Array();
        foreach ($group_list as $sub){
            $newsub=new group($sub);
            $id=$sub->get_attribute("ID");
            $hash_groups[$id]=$newsub;
        }
        $this->groups=new obj_set($hash_groups);
    }
    function xmldump($filename=''){
        global $xml_nuface_version;
        global $l7_mask;
        # create new xml document

        $xml = domxml_new_doc( '1.0' );
        $root = $xml->create_element('policy');
        $root->set_attribute('version',"$xml_nuface_version");
        $new_root = $xml->append_child($root);
        #descs
        $node = $xml->create_element( 'descs' );
        $newnode = $new_root->append_child($node);
        $this->descs->xmldump($xml,$newnode);
        #periods
        $node = $xml->create_element( 'periods' );
        $newnode = $new_root->append_child($node);
        $this->periods->xmldump($xml,$newnode);
        #ressources
        $node = $xml->create_element( 'ressources' );
        $newnode = $new_root->append_child($node);
        $this->ressources->xmldump($xml,$newnode);
        #subjects
        $node = $xml->create_element( 'subjects' );
        $newnode = $new_root->append_child($node);
        $this->subjects->xmldump($xml,$newnode);
        #applications
        $node = $xml->create_element( 'applications' );
        $newnode = $new_root->append_child($node);
        $this->applications->xmldump($xml,$newnode);
        #protocols
        $node = $xml->create_element( 'protocols' );
        $newnode = $new_root->append_child($node);
        $this->protocols->xmldump($xml,$newnode);
        #L7rules
        $node = $xml->create_element( 'l7rules' );
        $newnode = $new_root->append_child($node);
        if (isset($l7_mask) and ($l7_mask!=""))
        {
          $node->set_attribute('mask',$l7_mask);
        }
        $this->l7rules->xmldump($xml,$newnode);
        #acls
        $node = $xml->create_element( 'acls' );
        $newnode = $new_root->append_child($node);
        $this->acls->xmldump($xml,$newnode);
        #snats
        $node = $xml->create_element( 'snats' );
        $newnode = $new_root->append_child($node);
        $this->snats->xmldump($xml,$newnode);
        #dnats
        $node = $xml->create_element( 'dnats' );
        $newnode = $new_root->append_child($node);
        $this->dnats->xmldump($xml,$newnode);
        #pnats
        $node = $xml->create_element( 'pnats' );
        $newnode = $new_root->append_child($node);
        $this->pnats->xmldump($xml,$newnode);
        #groups
        $node = $xml->create_element( 'groups' );
        $newnode = $new_root->append_child($node);
        $this->groups->xmldump($xml,$newnode);
        # dump xml document
        if ($filename=='')
        {
          echo $xml->dump_mem( true, 'UTF-8' ) ;
          return(1);
        }else{
          return($xml->dump_file($filename,false,true));
        }
    }
}


function read_file($filename){
  global $datadir;
  if (!check_filename($filename))
    return(-1);
  if (!file_exists($datadir.'/'.$filename))
  {
    return(-1);
  }
  $expolicy= new policy($datadir.'/'.$filename);
  return $expolicy;
}

function read_desc_file($filename){
  global $network_desc_dir;
  if (!check_filename($filename))
  {
    print("BAD FILENAME");
    return(-1);
  }
  if (!file_exists($network_desc_dir.'/'.$filename))
  {
    print("NO FILE : ".$network_desc_dir.'/'.$filename);
    return(-1);
  }
  $expolicy= new desc($network_desc_dir.'/'.$filename,'file',"1");
  #return $expolicy->networks;
  return $expolicy;
}

function save_file($expolicy,$filename='',$check){
  $used_desc = $_SESSION['used_desc'];
  $descs=$expolicy->descs;
  $expolicy = check_acls_from_to ($expolicy,$descs->elts[$used_desc]);

  global $mess_error_not_saving_ACL;
  global $mess_error_not_saving_subjects;
  global $mess_error_not_saving_ressources;
  global $mess_error_not_saving_protocols;
  global $mess_error_not_saving_applications;
  global $mess_error_not_saving_l7rules;
  global $mess_error_not_saving_periods;


  if ($check>0)
  {
    if (!check_acls_completeness($expolicy->acls))
    {
      add_log($mess_error_not_saving_ACL);
      return(NULL);
    }
    if (!check_objects_completeness($expolicy->subjects, 1)) ## 1 means we are on a subjects context
    {
      add_log($mess_error_not_saving_subjects);
      return(NULL);
    }
    if (!check_objects_completeness($expolicy->ressources, 2)) ## 2 means we are on a ressources context
    {
      add_log($mess_error_not_saving_ressources);
      return(NULL);
    }
    if (!check_objects_completeness($expolicy->protocols, 3)) ## 3 means we are on a protocols context
    {
      add_log($mess_error_not_saving_protocols);
      return(NULL);
    }
    if (!check_objects_completeness($expolicy->l7rules, 4)) ## 4 means l7
    {
      add_log($mess_error_not_saving_l7rules);
      return(NULL);
    }
    if (!check_objects_completeness($expolicy->applications, 5)) ## 5 means applications
    {
      add_log($mess_error_not_saving_applications);
      return(NULL);
    }
    if (!check_objects_completeness($expolicy->periods, 6)) ## 6 means periods
    {
      add_log($mess_error_not_saving_periods);
      return(NULL);
    }
  }
  global $datadir;
  if (!check_filename($filename))
    return(NULL);
  if ($filename==''){
    return($expolicy->xmldump());
  } else {
    $_SESSION['xml_file'] = $filename;
    return($expolicy->xmldump($datadir.'/'.$filename));
  }
}

function del_file($filename=''){
  global $datadir;
  if (!check_filename($filename))
    return(-1);
  if ($filename==''){
    return(0);
  }
  return(unlink($datadir.'/'.$filename));
}

function cmp_file($elt1, $elt2){
 if ($elt1["mtime"] == $elt2["mtime"])
 {
   return 0;
 }
 return ($elt2["mtime"] > $elt1["mtime"]) ? 1: -1;
}

function file_list(){
 global $datadir;
 $files = array();
 $res = array();
 $dir = @opendir($datadir);
 if (! $dir)
 {
require_once("include/headers.php");
echo "<div class=content><div class=console>Could not open directory \$datadir!\n<div class=warning> Please check your configuration</div></div></div>";
    return(-1);
 }
 while(($file = readdir($dir)) !== false)
 {
  if($file !== '.' && $file !== '..' && !is_dir($file))
  {
    clearstatcache();
    $mtime = stat($datadir."/".$file);
    $mtime = $mtime["mtime"];
    $files[] = array("file" => $file, "mtime" => $mtime);
  }
 }
 closedir($dir);
 usort($files,"cmp_file");
 foreach($files as $elt)
 {
   $res[] = $elt["file"];
 }
 return($res);
}

function max_elt($array)
{
  $max=0;
  if (isset($array) and ($array!=''))
    foreach ($array as $elt)
    {
      $local=$elt->get_ID();
      if ($local>$max)
        $max=$local;
    }
  return($max);
}

function print_console($msg)
{
  print "<div class=\"console\">$msg</div>";
}

function print_consolebis($msg)
{
  print "<div class=\"console2\">$msg</div>";
}
$log_console='';
function add_log($text)
{
  global $log_console;
  $log_console .= $text."<br />";
}

function add_log_pre($text)
{
    add_log('<pre>'.htmlspecialchars($text).'</pre>');
}

function print_console2()
{
  global $log_console;
  if($log_console!=""){
    print_console($log_console);
  }
}

function begin_content_detail(){
  echo '<div class="content">';
  print_console2();
}

function end_content_detail(){
  //print_console2();
  echo '</div> <!-- content -->';
}

function begin_acls_use(){
  echo '<div class="acl_use">';
}

function show_acls_use($acls,$type,$id,$mess){
  $used=0;
  if (isset($acls->elts))
    foreach($acls->elts as $acl)
    {
    	print "<ul class='aclsuse'>";
      if (isset($acl->$type) and ($acl->$type == $id))
      {
#        print "<div class=\"".$acl->decision."\"><a href=\"acls.php?acl=".$acl->ID."\">".$acl->name."</a></div>\n";
        print "<li><form action=\"acls.php\"><span class=\"".$acl->decision."\">".$acl->name."</span><input type=hidden name=acl value=\"".$acl->ID."\">";
        print "<input type=image src=\"images/go.png\"></form>\n</li>";
        $used++;
      }
      print "</ul>";
    }
  if ($used == 0)
  {
    print "<i>$mess</i>";
  }
}

function end_acls_use(){
  echo "</div> <!-- acl_use -->\n";
}


function end_page(){
  require_once ('footer.php');
}

function log_and_exit($exit_code){
  begin_content_detail();
  end_content_detail();
  end_page();
  exit($exit_code);
}

function gen_nupyf_args($dir,$dispatch,$forward,$input,$output,$nat,$rescue, $mangle){
  $args = '';
  global $nupyf_no_same_iface;
  if ($rescue == true)
    $args .= $args . ' --rescue';
  if ($dispatch != '')
    $args .= " --dispatch $dir/$dispatch";
  if ($forward != '')
    $args .= " --forward $dir/$forward";
  if ($input != '')
    $args .= " --input $dir/$input";
  if ($output != '')
    $args .= " --output $dir/$output";
  if ($nat != '')
    $args .= " --nat $dir/$nat";
  if ($mangle != '')
    $args .= " --mangle $dir/$mangle";
  if ($nupyf_no_same_iface == 1)
    $args .= " --no-same-iface";
  return $args;
}

function report_execute($command,&$result){
  $handle = popen($command,'r');
  $ret = '';
  while(!feof($handle)){
    $ret .= fread($handle,2048);
  }
  $result = pclose($handle);
  return $ret;
}

function rename_if_exists($src,$dst){
  if (file_exists($src)){
    rename($src,$dst);
  }
}

function show_floatings($context,$floating,$gal_working_elts,$gal_type,$gal_name,$gal_quantity,$gal_operation,$gal_button_add,$in_elt,$elt,$page)
{
	if (isset($floating) and ($floating!=''))
	{
	  print "<div class=\"floating\">";
          print "<a href=\"#\" onclick=\"javascript:toggle_all_tab('tab1')\" onload=\"javascript:toggle_all_tab('tab1')\">$gal_working_elts</a>";
          print "<form action=\"$page.php\" method=\"POST\" name=\"floatform\">\n";

          print "<input type=\"hidden\" name=\"elt\" value=\"$elt\"/>\n";
	  print "<table id=\"tab1\"><thead><tr><td>$gal_name</td><td>$gal_type</td><td>$gal_quantity</td></tr></thead>";
#          print "<div class=\"menu\" id=\"tab1\">";
	  foreach($floating as $f_elt)
	  {
	    $data=$f_elt->get_obj();
            if (isset($context[$data['type']]))
            {
	      if (isset($data['name'])){
	        print "<tr><td>".$data['name']."</td><td>".$data['type']."</td><td>";
	        if ($in_elt == 1) {
	          print "<input class=\"quantity\" type=\"text\" name=\"add_float_".$data['ID']."\" value=\"0\" onClick=\"IncrementValue(add_float_".$data['ID'].");\"/>\n";
	        } else {
	          print "N/A";
                }
	        print "</td></tr>";
	      }
	      else{
	        print "<tr><td>".$data['ID']."</td><td>".$data['type']."</td><td>";
	        if ($in_elt == 1) {
	          print "<input class=\"quantity\" type=\"text\" name=\"add_float_".$data['ID']."\" value=\"0\" onClick=\"IncrementValue(add_float_".$data['ID'].");\"/>\n";
	        } else {
	          print "N/A";
                }
	        print "</td></tr>";
	      }
	    }
          }
          if ($in_elt == 1) {
              print "<tr><td colspan=\"3\" class=\"submit_cell\"><input type=submit value=\"$gal_button_add\" class=\"button\"></td></tr>\n";
          }
          print "</table>";
          print "</div>";
	}
}

function init_floatings(&$floating)
{
  global $nufw_firewall;
  global $l7_firewall;
  global $support_periods;
  if (!isset($floating) or ($floating=='') or ($floating==array()))
  {
    $floating=array();
    if ($nufw_firewall)
    {
      $init=array('ipv4','local_ipv4','nufw','link','proto','app');
      if ($support_periods)
        array_push($init,'period');
    }else{
      $init=array('ipv4','local_ipv4','link','proto','app');
    }
    if ($l7_firewall)
    {
      array_push($init,'l7rule');
    }
    foreach ($init as $mytype)
    {
      $received['type']=$mytype;
      $received['name']='_'.$mytype;
      $new_elt=new elt($received,'data',max_elt($floating)+1);
      array_push($floating,$new_elt);
    }
  $_SESSION['floating_elts']=serialize($floating);
  }
}

function find_used_desc($desc_to_find,$desc_array)
{
#  add_log("find_used_desc");
  $i=0;
  if (is_array($desc_array->elts))
  {
    foreach ($desc_array->elts as $desc)
    {
      $i++;
      /*if (compare_descs($desc_to_find->networks,$desc)!=0)*/
      if (compare_descs(&$desc_to_find->networks,&$desc->networks)!=0)
      {
        return($i);
      }
#    add_log("===============");
    }
  }
  return(-1);
}

function compare_descs($desc1,$desc2)
{

#  print "real desc\n";
#  print_r($desc1);
#  print "our desc\n";
#  print_r($desc2);
  ###First, lets fix all IDs to lower case...
  if (is_array($desc1->elts))
  {
    foreach($desc1->elts as $net_desc)
    {
      if (isset($net_desc->datas['ID']))
      {
#        print "CONVERT MATCH 1\n";
        $net_desc->datas['id']=$net_desc->datas['ID'];
      }
#      if (isset($net_desc->datas['id'])){
#        print "NO CONVERT MATCH 1\n";
#      }
    }
  }
  if (is_array($desc2->elts))
  {
    foreach($desc2->elts as $net_desc)
    {
      if (isset($net_desc->datas['ID'])){
#       print "CONVERT MATCH 2\n";
        $net_desc->datas['id']=$net_desc->datas['ID'];
      }
#      if (isset($net_desc->datas['id'])){
#        print "NO CONVERT MATCH 2\n";
#      }
    }
  }

  $match1=array();
  $match2=array();
  $i=0;
  $j=0;
  if (isset($desc1->elts))
  {
    foreach($desc1->elts as $net_desc1)
    {
      $i++;
      $j=0;
     #print "First ";
      foreach($desc2->elts as $net_desc2)
      {
        $j++;
      # print "Second ";
        if ($net_desc1->datas['id'] == $net_desc2->datas['id'])
        if ($net_desc1->datas['dftroute'] == $net_desc2->datas['dftroute'])
        if ($net_desc1->datas['type'] == $net_desc2->datas['type'])
        {
          #print_r ($net_desc1);
          #print_r ($net_desc2);
          $array1=stringtonet($net_desc1->datas['addr']);
          $array2=stringtonet($net_desc2->datas['addr']);
#          array_push($array1,$array2);
#          print_r($array1);
#          add_log("Comparing".$array1[0]."/".$array1[1]." with ".$array2[0]."/".$array2[1]);
          if (compare_nets($array1[0],$array1[1],$array2[0],$array2[1]))
          {
#            add_log("YES");
            $match1[$i]=1;
            $match2[$j]=1;
          }
        }
      }
    }
  }
  if ($i!=$j)
  {
#    add_log("no match ij : $i vs $j");
    return(0);
  }
  for ($ii = 1; $ii <= $i; $ii++)
  {
    if ((!isset($match1[$ii]) or ($match1[$ii]!=1)))
    {
#      add_log("no match i");
      return(0);
    }
  }
  for ($ij = 1; $ij <= $j; $ij++)
  {
    if ((!isset($match2[$ij]) or ($match2[$ij]!=1)))
    {
#      add_log("no match j");
      return(0);
    }
  }
#  add_log("Match!!!!!");
  return(1);
}

function stringtonet($s)
{
  $splitted = preg_split("/\//",$s);
  if (count($splitted)>1)
    return ($splitted);
  if ($splitted[0] == "0.0.0.0")
  {
    array_push($splitted,"0.0.0.0");
    return($splitted);
  }
  array_push($splitted,"255.255.255.255");
  return($splitted);
}

function compare_nets($net1, $mask1, $net2, $mask2)
{
  if (Net_IPv4::getSubnet($net1,$mask1)!=Net_IPv4::getSubnet($net2,$mask2))
  {
    return(0);
  }
  if (Net_IPv4::getNetLength($mask1)!=Net_IPv4::getNetLength($mask2))
  {
    return(0);
  }
#  print "Similar nets! :  $net1/$mask1 <-> $net2/$mask2\n";
#  print Net_IPv4::getSubnet($net2,$mask2)."\n";
#  print Net_IPv4::getNetLength($mask2)."\n";
  return(1);
}

function build_new_desc($desc_to_add,$descs)
{

  $new_id = $descs->new_id();
  $our_desc=$desc_to_add;

#  print_r($our_desc);
#  print_r($descs);
#  exit(0);
  $new = new desc($our_desc,'data',$new_id);
  $i=0;
  foreach($our_desc->networks->elts as $net)
  {
    $net_content['ID']=$net->datas['id'];;
    $net_content['type']=$net->datas['type'];
    $net_content['addr']=$net->datas['addr'];
    $net_content['name']=$net->datas['name'];
    $net_content['dftroute']=$net->datas['dftroute'];
    $new_net = new network($net_content,'data',$net->datas['id']);
    $new->networks->add_elt($new_net,$net->datas['id']);
#    print_r($new_net);
  }
  if ($our_desc->addresses->elts)
  {
     foreach($our_desc->addresses->elts as $net)
     {
       $i++;
       $net_content['ID']=$net->datas['id'];;
       $net_content['addr']=$net->datas['addr'];
       $net_content['iface']=$net->datas['iface'];
       $net_content['name']="";
       $new_net = new address($net_content,'data',$i);
       $new->addresses->add_elt($new_net,$i);
     }
   }

#  $descs->elts[$new_id]=(desc)$our_desc;
#  $desc_to_add->networks['ID'] = $descs->new_id();
  $_SESSION['modified']=1;
  $descs->add_elt($new);
}

function netInNetwork($net1,$mask1,$net2,$mask2)
#Checks whether a network is included in another network
{
  $ip_calc = new Net_IPv4();
  $ip_calc->ip = $net1;
  if (preg_match("/\./",$mask1))
    $ip_calc->netmask = $mask1;
  else
    $ip_calc->bitmask = $mask1;
  $ip_calc->calculate();
  if (!Net_IPv4::ipInNetwork($ip_calc->network, $net2."/".$mask2))
  {
    return(0);
  }
  if (!Net_IPv4::ipInNetwork($ip_calc->broadcast, $net2."/".$mask2))
  {
    return(0);
  }
#  add_log($net1."/".$mask1." is in ".$net2."/".$mask2);
  return(1);
}

function netIntersectsNetwork($net1,$mask1,$net2,$mask2)
#Checks wether two networks have a non-empty intersection
{
  $ip1_calc = new Net_IPv4();
  $ip2_calc = new Net_IPv4();
  $ip1_calc->ip = $net1;
  if (preg_match("/\./",$mask1))
    $ip1_calc->netmask = $mask1;
  else
    $ip1_calc->bitmask = $mask1;
  $ip1_calc->calculate();
  $ip2_calc->ip = $net2;
  if (preg_match("/\./",$mask2))
    $ip2_calc->netmask = $mask2;
  else
    $ip2_calc->bitmask = $mask2;
  $ip2_calc->calculate();
  if ((Net_IPv4::ip2double($ip1_calc->network)>Net_IPv4::ip2double($ip2_calc->broadcast))
   or (Net_IPv4::ip2double($ip2_calc->network)>Net_IPv4::ip2double($ip1_calc->broadcast)))
  return(0);
  return(1);

}

function check_objects_from_desc($objects,$used_desc)
{
  #First, build an array with our network adresses
  $addrs = array();
  if (is_array($used_desc->elts))
  {
    foreach ($used_desc->elts as $desc)
    {
      if ((($desc->datas['type'] == 'ipv4') or ($desc->datas['type'] == 'mark')) and (!preg_match("/^0\.0\.0\.0/",$desc->datas['addr'])))
        array_push($addrs,$desc->datas['addr']);
    }
  }
  if (is_array($objects->list_tab()))
  {
    foreach (($objects->list_tab()) as $key=>$unused)
    {
      $object = $objects->get_elt($key);
      foreach ($object->elts as $sub_obj)
      {
        if ($sub_obj->datas['type']!='ipv4')
          continue;
        if (preg_match("/^0\.0\.0\.0/",$sub_obj->datas['net']))
          continue;
      #This element must either have a NULL intersection with the net, or be included in it
#      $inter=0;
        $baddr=stringtonet($sub_obj->datas['net']);
        foreach ($addrs as $addr)
        {
          $aaddr=stringtonet($addr);
          if (netIntersectsNetwork($baddr[0],$baddr[1],$aaddr[0],$aaddr[1]))
          {
#          $inter++;
            if (!netInNetwork($baddr[0],$baddr[1],$aaddr[0],$aaddr[1]))
            {
              $objects->elts[$key]->elts[$sub_obj->datas['ID']]->datas['invalid']=1;
              add_log("Invalid adress found : ".$sub_obj->datas['net']);
            }
#            add_log($sub_obj->get_id());

#            $sub_obj->datas['invalid']=1;
#            add_log("BAD : ".$sub_obj->datas['net']." ".$addr);
#            else
#          add_log("GOOD : ".$sub_obj->datas['net']." ".$addr);
          }
        }
      }
    }
  }
}

function build_bichains($used_desc)
{
  #If desc lives with 3 networks defined, we need to create 6 FWD bichains + 3 +3 (in/out) bichains
  $res=array();
  foreach ($used_desc->networks->elts as $desc)
  {
    if (isset($desc->datas['ID']))
    {
      $tmp_a[$desc->datas['ID']] = $desc->datas['name'];
    }
    else if (isset($desc->datas['id']))
    {
      $tmp_a[$desc->datas['id']] = $desc->datas['name'];
    }
  }
  #$max=0;
  #foreach ($tmp_a as $key)
  #{
  #  $max=$key if $key>$max;
  #}
  global $fw_chain;
#  array_push($tmp_a, $fw_chain);
  $i=1;
  foreach ($tmp_a as $key=>$value)
  {
    foreach ($tmp_a as $key2=>$value2)
    {
      if ($key == $key2)
        continue;
      $res[$i]['from']=$key;
      $res[$i]['label']=$value.'-';
      $res[$i]['to']=$key2;
      $res[$i]['label']=$res[$i]['label'].$value2;
      $res[$i]['max']=0;
      $i++;
    }
  }
#FROM-LOCAL elements
  foreach ($tmp_a as $key=>$value)
  {
    $res[$i]['from']=$key;
    $res[$i]['label']=$value.'-'.$fw_chain;
    $res[$i]['to']=-1;
    $res[$i]['max']=0;
    $i++;
  }
#LOCAL-TO elements
  foreach ($tmp_a as $key=>$value)
  {
    $res[$i]['from']=-1;
    $res[$i]['label']=$fw_chain.'-'.$value;
    $res[$i]['to']=$key;
    $res[$i]['max']=0;
    $i++;
  }
  return($res);
}

function print_js_groups_tab($groups){
    $array_groups = array();
    foreach ($groups->list_tab() as $key=>$foo){
       array_push($array_groups,$key);
    }
    echo '<script>';
    echo 'glob_groups_t = Array();';
    foreach ($array_groups as $key){
        $group=$groups->get_elt($key);
        $enabled = $group->enabled == 1? '1':'0';
        echo "glob_groups_t['$key']=$enabled;";
    }
    echo "</script>\n";
}


/*
 * This function read opened file represented by handler
 * and returns array of strings, each a line from the file
 */
function freadlines($handle){
    $output= array();
    if ($handle){
        while (!feof($handle)){
            $l= trim(fgets($handle));
            $output[] = $l;
        }
    }
    return $output;
}

/*
 *   get groups: name and gid
 * $file: path to file to read instead of running getent
 * $sysgroupfile: path to local groups file. groups belonging to this file will not be included
 * in final result
 * return: array gid=>name
*/
function getent_user_groups($file='', $sysgroupfile=''){
    global $decode_groups_from_utf8;
    $output = array();
    $sysgroups = array();
    $ret = 0;
    $result = array();
    /*if file is set, get group from it instead of getent */
    if($file != ''){
        $handle = fopen($file,'r');
        if($handle){
            $output = freadlines($handle);
            fclose($handle);
        }
    }else{
        exec("getent group",$output,$ret);
    }
    if($sysgroupfile != ''){//get groups from /etc/group
        $handleg = fopen($sysgroupfile,'r');
        $linesg = freadlines($handleg);
        foreach($linesg as $line){
            $t = explode(':',$line);
            $sysgroups[] = $t[0];
        }
    }
    foreach($output as $line){
        /* $line is group_name:x:gid: */
        $t = explode(':',$line);
        if (!in_array($t[0], $sysgroups)){//add groups to result only if not in sysgroups
            $result[$t[2]] = $t[0];
        }
    }
    if ($decode_groups_from_utf8)
    {
      foreach ($result as $key=>$value)
      {
        $result[$key] = utf8_decode($result[$key]);
      }
    }
    return $result;
}

function bichain_touches_acl($bichain,$acl)
{
#  print_r($bichain);
#IN : the bichain structure, and the concerned ACL
#OUT : 1 if acl is concerned, 0 else
  $used_desc = $_SESSION['used_desc'];
  if (is_array($acl->descsorts->elts[$used_desc]->elts))
  {
    foreach ($acl->descsorts->elts[$used_desc]->elts as $id=>$tab)
    {
#    print_r($tab);
#    print "Comparing ".$tab->from." with ".$bichain['from'];
      if (($tab->from == $bichain['from']) and
          ($tab->to   == $bichain['to']))
        return(1);
      #deal with local rules
      if ($tab->from == 0 - $tab->to)
      {
        if (($tab->from == $bichain['from']) and
            ($tab->to   == $bichain['to'])){
          print $tab->from . " == ".$bichain['from']. " or ";
          print $tab->to . " == ".$bichain['to']."\n";

          return(1);
        }
      }
    }
  }
  return(0);
}


#
# Test if acl has a rule going from or coming to network
# identified by network_id
function acl_touches_network($acl, $direction, $network_id){
    $used_desc = $_SESSION['used_desc'];
    foreach ($acl->descsorts->elts[$used_desc]->elts as $id=>$tab){
          if ($direction == 'from' and $tab->from == $network_id){
              return true;
          }
          if ($direction == 'to' and $tab->to == $network_id){
              return true;
          }
    }
    return false;
}

function populate_bichains_max($bichains,$acls)
{
  $used_desc = $_SESSION['used_desc'];
  if (is_array($acls->elts))
  {
    foreach ($acls->elts as $id=>$acl)
    {
      if (is_array($acl->descsorts->elts[$used_desc]->elts))
      {
        foreach ($acl->descsorts->elts[$used_desc]->elts as $idorder=>$tab)
        {
          foreach ($bichains as $idbichain=>$bichain)
          {
            if (($bichain['from']!= $tab->from) or
                ($bichain['to']  != $tab->to))
              continue;
            if ($tab->order > $bichain['max'])
            {
              $bichain['max'] = $tab->order;
#             add_log($bichain['label']." got a new max : ".$tab->order);
              $bichains[$idbichain]=$bichain;
            }
          }
        }
      }
    }
  }
  return($bichains);
}

# in bichains, get the one which label is name
function get_bichain_by_name($bichains, $name){
    if (is_array($bichains))
    {
      foreach($bichains as $bichain){
          if ($bichain['label'] == $name){
              return $bichain;
          }
      }
    }
    return null;
}

function check_acls_order_scheme($acls)
{
#Check for unicity of orders for a given (from,to).
#Check all Acls have orders correctly specified
  $used_desc = $_SESSION['used_desc'];
  $seen=array();
  if (is_array($acls->elts))
  {
    foreach ($acls->elts as $id=>$acl)
    {
      if (is_array($acl->descsorts->elts[$used_desc]->elts))
      {
        foreach ($acl->descsorts->elts[$used_desc]->elts as $idorder=>$tab)
        {
          if (!isset($seen[$tab->from][$tab->to][$tab->order]))
            $seen[$tab->from][$tab->to][$tab->order]=1;
          else
            return(-1);
        }
      }
    }
  }
  return(0);
}

function get_nets($context,$id,$document)
{
  if (($context!='from') and ($context!='to'))
  {
    return array();
  }
  $result=array();
  $object = $document->ressources;
  if ($context=='from')
  {
    $object = $document->subjects;
  }
  $obj = $object->get_elt_by_id($id);
  {
    if (is_array($obj->elts))
    {
      foreach (($obj->elts) as $elt_id=>$elt)
      {
        if ($elt->datas['type']=='local_ipv4')
        {
          array_push($result,'local_ipv4');
        }
        else if ($elt->datas['type']=='ipv4' or $elt->datas['type'] == 'mark')
        {
          array_push($result,$elt->datas['net']);
#        print "context : $context found ".$elt->datas['net']."\n";
#        print_r($elt->datas);
 #       print_r($elt->datas);
        }else if ($elt->datas['type']=='link')
        {
          $result = array_merge($result,get_nets($context,$elt->datas['linkid'],$document));
        }else if ($elt->datas['type']=='nufw')
        {
          array_push($result,'all');
        }
      }
    }
  }
  $result=array_unique($result);
  if (count($result)==0)
  {
    array_push($result,'all');
  }
#  print "get_nets was called on $context, $id";
#  print_r($result);
  return($result);
}

function fill_seen_tab($net_array,$desc,$descnets)
{
    $result=array();
    foreach($net_array as $id=>$net)
    {
      $seen=0;
      $dftroute=0;
      if ($net == 'local_ipv4')
      {
        #pushing a special "0" value if local
        array_push($result,-1);
        continue;
      }

      foreach($descnets as $addr=>$this_desc)
      {
        #Find the default route, used later (search DFTROUTE)
        if (isset($this_desc->datas['dftroute']))
        {
          $dftroute="";
          if (isset($this_desc->datas['ID']))
          {
            $dftroute=$this_desc->datas['ID'];
          }else if (isset($this_desc->datas['id']))
          {
            $dftroute=$this_desc->datas['id'];
          }
        }
        if ((($this_desc->datas['type']) != 'ipv4') and (($this_desc->datas['type']) != 'mark'))
        {
          continue;
        }
        $net1 = stringtonet($net);
        $net2 = stringtonet($this_desc->datas['addr']);
        if (netInNetwork($net1[0],$net1[1],$net2[0],$net2[1]))
        {
          if (isset($this_desc->datas['ID']))
          {
            array_push($result,$this_desc->datas['ID']);
          }else if (isset($this_desc->datas['id']))
          {
            array_push($result,$this_desc->datas['id']);
          }
          $seen=1;
          break;
        }
      }

      if ($seen==0) #Not seen, means internet
      {
        array_push($result,$dftroute);
      }
    }

    return($result);
}

function check_acl_from_to($acl_id,$document,$desc,$descnets)
{
	global $totaltime;
    $used_desc = $_SESSION['used_desc'];
    $acls = &$document->acls;
    $acl = &$acls->elts[$acl_id];

    #Remplissons un tableau aves les reseaux qui ne contiennent pas la route par defaut
    #ce tableau va nous servir pour forcer ces reseaux sur les sujets purement
    #authentifiants
    $all_nets_but_dftgtw = array();
    foreach ($desc->networks->elts as $this_net)
    {
        if (!isset ($this_net->datas['dftroute']) or ($this_net->datas['dftroute'] != 1))
        {
          if (isset($this_net->datas['ID']))
          {
            array_push($all_nets_but_dftgtw,$this_net->datas['ID']);
          }else if (isset($this_net->datas['id']))
          {
            array_push($all_nets_but_dftgtw,$this_net->datas['id']);
          }
        }
    }

    #liste des reseaux sujets et ressources concernes par l'ACL $acl
    $from_net=get_nets('from',$acl->from,$document);
    $to_net=get_nets('to',$acl->to,$document);

    //print "===== ACL ".$acl->ID."=====\n";

    #Liste des identifiants desc.xml concernes par ces reseaux

    $from_desc_ids = fill_seen_tab($from_net,$desc,$descnets);
    //print_pre("FROM::");
    //print_pre($from_desc_ids);
    $to_desc_ids = fill_seen_tab($to_net,$desc,$descnets);
    //print_pre("TO::");
    //print_pre($to_desc_ids);


    if (in_array('all',$from_net))
    {
      $from_desc_ids = $all_nets_but_dftgtw;
    }


    #Reste a comparer le croisement de ces listes avec ceux stockes dans l'ACL elle-meme
    #Commencons par supprimer les marqueurs superflus
    if (is_array($acl->descsorts->elts[$used_desc]->elts))
    {
      //print_pre('$acl->descsorts->elts[$used_desc]->elts BEFORE::');
      //print_pre($acl->descsorts->elts[$used_desc]->elts);
      foreach ($acl->descsorts->elts[$used_desc]->elts as $idorder=>$tab)
      {
        if ((!in_array($tab->from,$from_desc_ids)) or (!in_array($tab->to,$to_desc_ids)))
        {
            #Keys not found in the real world, removing
            unset($acl->descsorts->elts[$used_desc]->elts[$idorder]);
            //print_pre(" * Removing ".$tab->from." => ".$tab->to);
#           $acls2->elts[$id]=$acl;
        }
      }
      //print_pre('$acl->descsorts->elts[$used_desc]->elts AFTER::');
      //print_pre($acl->descsorts->elts[$used_desc]->elts);
    }
    #Et creons les marqueurs manquants

      #Si une ACL n'a aucun reseau en source, on prend tous les reseaux sauf la
      #route par defaut
    if ($from_desc_ids == array ())
    {
      $from_desc_ids = $all_nets_but_dftgtw;
    }

    foreach ($from_desc_ids as $from)
    {
      foreach ($to_desc_ids as $to)
      {
         if (($from==0) and ($to==0))
         {
            #We don't deal with purely local rules [for now]
            continue;
         }
            #If the rule is local, the marker of the local interface is the opposite of the network's marker
         if ($from == 0)
         {
#           $from = 0 - $to;
           $from = -1;
         }
         if ($to == 0)
         {
#           $to = 0 - $from;
           $to = -1;
         }
         $order = $acl->get_order($used_desc,$from,$to);
         if ($order == 0)
         {
           /*$acl1=&$acls->get_elt($acl->ID);*/
           $acl1=&$acl;
           $acl1->set_order($used_desc,$from,$to,$acls->get_max_order($from,$to)+1,$acls->get_max_order_id()+1);
           $acls->del_elt($acl->ID);
           $acls->add_elt($acl1,$acl->ID);
         }
###        $seen=0;
###        foreach($acl->descsorts->elts[$used_desc]->elts as $idorder=>$tab)
###        {
###          if (($tab->from == $from) and ($tab->to == $to))
###          {
###            $seen=1;
###          }
###        }
###        if ($seen == 0)
###        {
####          print "Modifying ACL :\n";
####          print_r($acl);
###          $new_order{'from'}=$from;
###          $new_order{'to'}=$to;
####          print "Creating order : ".$acls->get_max_order($from,$to)+1;
###          $new_order{'order'}=$acls->get_max_order($from,$to)+1;
####          print "Creating ID : ".$acls->get_max_order_id()+1;
###          $new_elt = new order_elt($new_order,'data',$acls->get_max_order_id()+1);
###          if(!isset($acl->descsorts->elts[$used_desc]->elts))
###          {
###            $new_descsort = new descsort (array(),'data',$used_desc);
####            $acl->descsorts->elts[$used_desc]->elts=array();
####            $acl->descsorts->elts[$used_desc]->ID=$used_desc;
###            $acl->descsorts->elts[$used_desc]=$new_descsort;
###          }
###          $acl->descsorts->elts[$used_desc]->elts[$new_elt->ID]=$new_elt;
####          $acls2->del_elt($acl->ID);
####          $acls2->add_elt($acl);
####          print_r($acl);
####          print_r($acls);
####        }else{
####          print "($from,$to) NOT SEEN";
###        }
      }
    }
    #print_r($acl2);
    #return($acl2);
#    print_r($acls);
}


function check_acls_from_to($document,$desc)
{
#Check the "from" and "to" elements of acls are consistent with the desc scheme
  $_SESSION['need_acl_recalc']=0;
  $acls=&$document->acls;
#  $acls2 = $acls;
#  foreach ($acls->elts as $id=>$acl)
#  {
##    #liste des r�eaux sujets et ressources concern� par l'ACL $acl
##    $from_net=get_nets('from',$acl->from,$document);
##    $to_net=get_nets('to',$acl->to,$document);
##
##    #Liste des identifiants desc.xml concern� par ces r�eaux
##    $from_desc_ids = fill_seen_tab($from_net,$desc);
##    $to_desc_ids = fill_seen_tab($to_net,$desc);
##
##    #print "FROM FOUND : ";
##    #print_r($from_desc_ids);
##    #print_r($from_net);
##
##    #print "TO FOUND : ";
##    #print_r($to_desc_ids);
##    #print_r($to_net);
##
##    #Reste �comparer le croisement de ces listes avec ceux stock� dans l'ACL elle-m�e
##    #Commen�ns par supprimer les marqueurs superflus
##    foreach ($acl->descsorts->elts[$used_desc]->elts as $idorder=>$tab)
##    {
##      if ((!in_array($tab->from,$from_desc_ids)) or (!in_array($tab->to,$to_desc_ids)))
##      {
##          #Keys not found in the real world, removing
###          add_log("Deleting ".$tab->from." , ".$tab->to);
##          unset($acl->descsorts->elts[$used_desc]->elts[$idorder]);
##          $acls2->elts[$id]=$acl;
##      }
##    }
##    #Et cr�ns les marqueurs manquants
##    foreach ($from_desc_ids as $from)
##    {
##      foreach ($to_desc_ids as $to)
##      {
##        $seen=0;
##        foreach($acl->descsorts->elts[$used_desc]->elts as $idorder=>$tab)
##        {
##          if (($tab->from == $from) and ($tab->to == $to))
##          {
##            $seen=1;
##          }
##        }
##        if ($seen == 0)
##        {
###          print "Modifying ACL :\n";
###          print_r($acl);
##          $new_order{'from'}=$from;
##          $new_order{'to'}=$to;
##          $new_order{'order'}=$acls2->get_max_order($from,$to)+1;
##          $new_elt = new order_elt($new_order,'data',$acls2->get_max_order_id()+1);
##          if(!isset($acl->descsorts->elts[$used_desc]->elts))
##          {
##            $new_descsort = new descsort (array(),'data',$used_desc);
###            $acl->descsorts->elts[$used_desc]->elts=array();
###            $acl->descsorts->elts[$used_desc]->ID=$used_desc;
##            $acl->descsorts->elts[$used_desc]=$new_descsort;
##          }
##          $acl->descsorts->elts[$used_desc]->elts[$new_elt->ID]=$new_elt;
##          $acls2->del_elt($acl->ID);
##          $acls2->add_elt($acl);
###          print_r($acl);
###          print_r($acls);
##        }
##      }
#    }
#    print_r($acl);
#    check_acl_from_to($acl,$document,$desc);
#  }
#  $document->acls=$acls2;
  if (isset($acls))
  {
    $list=$acls->ordered_list_tab();
  }
  if (!isset($list))
  {
    $list=array();
  }
  if (is_array($list))
  {
      require_once('netmask_list.php');
      $netlist = new NetmaskList();
      foreach ($desc->networks->elts as $id_d=>$this_desc) {

        $netlist->addNetmask($this_desc->datas['addr'], $this_desc);
      }
      $descnets = $netlist->getArray();

	$starttime = getmicrotime();
    foreach ($list as $is=>$value)
    {
     $acl = &$acls->get_elt($is);
     $used_desc = $_SESSION['used_desc'];
     //print_pre('$acl->descsorts->elts[$used_desc]->elts PRE-BEFORE::');
     //print_pre($acl->descsorts->elts[$used_desc]->elts);
     check_acl_from_to($is,&$document,$desc,$descnets);
     //print_pre('$acl->descsorts->elts[$used_desc]->elts POST-AFTER::');
     //print_pre($acl->descsorts->elts[$used_desc]->elts);
    }
  }

  return($document);
}

function check_acls_completeness($acls)
{
  global $mess_error_acl_no_subject;
  global $mess_error_acl_no_ressource;
  global $mess_error_acl_no_decision;
  $problem=0;
  if (is_array($acls->elts))
  {
    foreach ($acls->elts as $id=>$acl)
    {
      if (!isset($acl->from))
      {
        add_log($mess_error_acl_no_subject."<a href=\"acls.php?acl=".$acl->ID."\">".$acl->name."</a>");
        $problem++;
      }
      if (!isset($acl->to))
      {
        add_log($mess_error_acl_no_ressource."<a href=\"acls.php?acl=".$acl->ID."\">".$acl->name."</a>");
        $problem++;
      }
      if (!isset($acl->decision))
      {
        add_log($mess_error_acl_no_decision."<a href=\"acls.php?acl=".$acl->ID."\">".$acl->name."</a>");
        $problem++;
      }
    }
  }
  if ($problem>0)
  {
    add_log($problem." problem(s) found!");
    return(0);
  }
  return(1);
}

function check_objects_completeness($object, $context)
{
  $document=unserialize($_SESSION['document']);
  $used_desc=$_SESSION['used_desc'];
  $local_addresses=array();

  global $mess_error_check_local_prefix_array;
  global $mess_error_check_local_suffix;
  global $mess_error_check_net_def_array;
  global $mess_error_check_ipv4_prefix_array;
  global $mess_error_check_ipv4_suffix;
  global $mess_error_check_nufw_group;
  global $mess_error_check_proto_empty;
  global $mess_error_check_linkid_array;
  global $mess_error_check_object_empty_array;

  if ($context==1)
  {
    $page="subjects.php";
  }
  if ($context==2)
  {
    $page="ressources.php";
  }
  if ($context==3)
  {
    $page="protocols.php";
  }
  if ($context==4)
  {
    $page="l7rules.php";
  }
  if ($context==5)
  {
    $page="applications.php";
  }
  if ($context==6)
  {
    $page="periods.php";
  }



#  print "USED DESC : $used_desc";
#  print_r($document->descs);
  if (is_array($document->descs->elts[$used_desc]->addresses->elts))
  {
    foreach($document->descs->elts[$used_desc]->addresses->elts as $addr_obj)
    {
      if (isset($addr_obj->datas))
      {
        array_push($local_addresses,$addr_obj->datas['addr']);
      }
    }
  }
#  print_r($local_addresses);
  $problem=0;
  if (is_array($object->elts))
  {
    foreach($object->elts as $id=>$obj)
    {
      $elt_count=0; #doit finir non vide
      if (is_array($obj->elts))
      {
        foreach ($obj->elts as $eid=>$elt)
        {
          $elt_count++;
          if ($elt->datas['type']=='local_ipv4')
          {
            if ((!isset($elt->datas['net'])) or ($elt->datas['net'] == ''))
            {
              continue; #local_ipv4 element may have an empty net
            }
            if (!in_array($elt->datas['net'],$local_addresses))
            {
              add_log($mess_error_check_local_prefix_array[$context]."<a href=\"$page?elt=".$obj->ID."&sub_elt=".$elt->datas['ID']."\">".$obj->name." -> ".$elt->datas['name']."</a>".$mess_error_check_local_suffix);
              $problem++;
            }
          }
          if ($elt->datas['type']=='ipv4' or $elt->datas['type'] == 'mark')
          {
            if ((!isset($elt->datas['net'])) or ($elt->datas['net'] == ''))
            {
              add_log($mess_error_check_net_def_array[$context]."<a href=\"$page?elt=".$obj->ID."&sub_elt=".$elt->datas['ID']."\">".  $obj->name." -> ".$elt->datas['name']."</a>");
              $problem++;
            }
            if (in_array($elt->datas['net'],$local_addresses))
            {
              add_log($mess_error_check_ipv4_prefix_array[$context]."<a href=\"$page?elt=".$obj->ID."&sub_elt=".$elt->datas['ID']."\">".  $obj->name." -> ".$elt->datas['name']."</a>".$mess_error_check_ipv4_suffix);
              $problem++;
            }

          }
          if ($elt->datas['type']=='nufw')
          {
            if ((!isset($elt->datas['group']) or ($elt->datas['group'] == '')))
            {
              add_log($mess_error_check_nufw_group."<a href=\"$page?elt=".$obj->ID."&sub_elt=".$elt->datas['ID']."\">".  $obj->name." -> ".$elt->datas['name']."</a>");
              $problem++;
            }

          }
          if ($elt->datas['type']=='proto')
          {
            if ((!isset($elt->datas['proto']) or ($elt->datas['proto'] == '')))
            {
              add_log($mess_error_check_proto_empty."<a href=\"protocols.php?elt=".$obj->ID."&sub_elt=".$elt->datas['ID']."\">".  $obj->name." -> ".$elt->datas['name']."</a>");
              $problem++;
            }
          }
          if ($elt->datas['type']=='link')
          {
            if ((!isset($elt->datas['linkid']) or ($elt->datas['linkid'] == '')))
            {
              add_log($mess_error_check_linkid_array[$context]."<a href=\"$page?elt=".$obj->ID."&sub_elt=".$elt->datas['ID']."\">".$obj->name." -> ".$elt->datas['name']."</a>");
              $problem++;
            }
          }
        }
      }
      if ($context != 4) # L7 objects may contain no element
      {
        if ($elt_count==0)
        {
          add_log($mess_error_check_object_empty_array[$context]."<a href=\"$page?elt=".$obj->ID."\">".$obj->name."</a>");
          $problem++;
        }
      }
    }
  }
  if ($problem>0)
    return(0);
  return(1);
}


# Get chains names from policy
function get_chains($policy, $used_desc){
    global $fw_chain;
    # put artifical chains
    $res = array($fw_chain);
    $descs = $policy->descs;
    $desc = $descs->elts[$used_desc];
    $networks = $desc->networks;
    foreach($networks->elts as $key=>$network){
        $data = $network->datas;
        $res[] = $data['name'];
    }
    return $res;
}


function sync_subjects(&$document)
{
  $document->subjects=$document->ressources;
  foreach ($document->subjects->elts as $id=>$obj)
  {
     if (!isset($obj->operator) or ($obj->operator==''))
       $obj->operator='or';
     $document->subjects->elts[$id]=$obj;
  }

}

function display_openfile_menu()
{
  global $network_desc_file;
  global $mess_desc_file_choice;
  global $mess_index_button_open;
  global $gal_load_valid_xml_file;

  $files=file_list();
#  print "<div class='action' id='action1'>\n";
  print "<span class=\"error\">$gal_load_valid_xml_file</span>";
  print "<form action=\"index.php\" method=POST>\n";
  print " <select name=\"input_file\">\n";
    if (!isset($files))
    {
      $files=array();
    }
    foreach($files as $file){
      echo "    <option>$file</option>\n";
    }
  print "</select>";

  if (is_array($network_desc_file))
  {
    print "<br>$mess_desc_file_choice";
    print " <select name=\"used_desc_file\">";
    foreach($network_desc_file as $file){
      echo "    <option>$file</option>\n";
    }
    print "</select>";
  }else{
    print "<input type=hidden name=\"used_desc_file\" value=\"$network_desc_file\">";
  }

  print "<INPUT type=\"submit\" value=\"$mess_index_button_open\" class=\"button\">";
  print "</form>";
#  print "</div>";

}

function forget_nuface_session()
{
        $document=array();
        $_SESSION['document']=serialize($document);
        $_SESSION['floating_elts']=serialize($document);
        $_SESSION['used_desc']=-1;
        $_SESSION['modified']=0;
        unset($_SESSION['bichains']);
        unset($_SESSION['xml_file']);
}

?>
