<?php
#
# Copyright(C) 2004-2006 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#            Jean Gillaux <jean@inl.fr>
#            Damien Boucard <damien.boucard AT inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

session_start();
require_once ("include/function.php");
require_once ("/etc/nuface/config.php");
require_once ("include/messages.php");

$title='index';
$input=$_REQUEST['input_file'];
$generate=$_REQUEST['generate'];
$used_file=$_REQUEST['used_file'];
$used_desc_file=$_REQUEST['used_desc_file'];
$reload_rules=$_REQUEST['reload_rules'];
$reload_by_hand=$_REQUEST['reload_by_hand'];
$reload_rules_type=$_REQUEST['reload_rules_type'];
$xml_download=$_REQUEST['xml_download'];
$upload_file=$_REQUEST['upload_file'];
$save_and_apply=$_REQUEST['save_and_apply'];

if (!check_filename($used_file))
{
  add_log("Bad filename");
  exit(0);
}
if (!check_filename($used_desc_file))
{
  add_log("Bad filename");
  exit(0);
}

#if (!posix_access($datadir,POSIX_R_OK | POSIX_X_OK))
#{
#  add_log($bad_fs_perms_message);
#  exit(0);
#}

#if (!$is_demo)
#{
#  if (!posix_access($datadir,POSIX_R_OK | POSIX_W_OK | POSIX_X_OK))
#  {
#    add_log($bad_fs_perms_message);
#    exit(0);
#  }
#}

#
# Find right desc in document
# create it if it does not exist
#
function find_build_desc($document, $desc_file){
    if (!isset($desc_file))
    {
        add_log("No desc file?");
        return(null);
    }
    session_start();

    $desc_from_file = read_desc_file($desc_file);
    if ($desc_from_file === -1)
    {
        add_log($mess_index_desc_file_read_pb);
        log_and_exit(-1);
    }

    #  $expolicy=unserialize($_SESSION['document']);
    $descs=&$document->descs;
#  print_r($descs);
#  print "-----------------\n";
#  print_r($document->ressources);
#  print "=================\n";

    $used_desc=find_used_desc($desc_from_file,$descs);
    if ($used_desc < 0)
    {
#        add_log("Creating desc :".$used_desc);
        build_new_desc($desc_from_file,&$descs);
        $used_desc=find_used_desc($desc_from_file,$descs);
#        add_log("NEW USED DESC : $used_desc");
    }

    return $used_desc;
}

function generate_rules($file)
{
  global $nupyf_command;
  global $manage_input;
  global $manage_output;
  global $manage_nat;
  global $nufw_rules_dir;
  global $nufw_firewall;
  global $l7_firewall;
  global $l7_command;
  global $std_rules_dir;
  global $network_desc_file;
  global $used_desc_file;
  global $network_desc_dir;
  global $datadir;
  global $mess_error;
  global $mess_error_periods;
  global $mess_ok;
  global $mess_ok_redundant;
  global $support_duplication;
  global $rules_modified;
  global $rules_dir;
  global $nupyf_ldap_file;
  global $nupyf_conf_file;
  global $desc_file;
  global $nuperiod_command;
  global $periods_file;
  global $rules_dir;
  global $mess_no_delete;
  global $disable_check_net;

  $desc_file="";
  if (is_array($network_desc_file))
  {
      $desc_file=$used_desc_file;
  }else{
      $desc_file=$network_desc_file;
  }

  #print "desc_file: $desc_file";
  #print "acls_file: $file";
  $document=read_file($file);
  $used_desc = find_build_desc(&$document, $desc_file);
  if($used_desc == null){
     log_and_exit(-1);
  }

#  add_log("used_desc: $used_desc");
  if ($_SESSION['modified']!=0)
          {
            add_log($rules_modified);
          }else{
	#          add_log($nupyf_command." ".$network_desc_dir."/".$network_desc_file." ".$datadir."/".$used_file.">".$rules_dir."/".$nufw_rules_file);
	#          add_log($nupyf_command." --std ".$rules_dir."/".$std_rules_file." ".$network_desc_dir."/".$network_desc_file." ".$datadir."/".$used_file);
		  $input_rules = ($manage_input == 0)? '': 'input_rules.tmp';
		  $output_rules = ($manage_output == 0)? '': 'output_rules.tmp';
		  $nat_rules = ($manage_nat == 0)? '': 'nat_rules.tmp';
                  $mangle_rules = 'mangle_rules.tmp';
		  $nupyf_args = gen_nupyf_args($nufw_rules_dir,'dispatch_rules.tmp','forward_rules.tmp',$input_rules,$output_rules,$nat_rules,false, $mangle_rules);
                  $nupyf_args.= " --sortid $used_desc";
		  if ($disable_check_net == true)
		  {
		    $nupyf_args.= " --no-check-net";
		  }
                  $result0=0;
                  $l7_rules = 'l7_rules.tmp';
                  $l7_res="";
                  if ((file_exists($rules_dir."/".$l7_rules)) and (!unlink($rules_dir."/".$l7_rules)))
                  {
                    add_log($mess_no_delete.$rules_dir."/".$l7_rules);
                  }
                  if ($l7_firewall)
                  {
                    $nupyf_args.= " --nulayer7";
                    $l7_cmd=$l7_command." --output=$rules_dir"."/"."$l7_rules $datadir"."/".$file." 2>&1";
                    #add_log($l7_cmd);
                    $l7_res = report_execute ($l7_cmd,$result0);
                  }
                  if ($nufw_firewall)
                  {
	            $nufw_cmd=$nupyf_command.$nupyf_args." --ulog --conf ".$network_desc_dir."/".$nupyf_conf_file." --dumpldap ".$rules_dir."/".$nupyf_ldap_file." ".$network_desc_dir."/".$desc_file." ".$datadir."/".$file." 2>&1";
		  #add_log($nufw_cmd);
	          //system($nufw_cmd,$result1);
		    $nupyf_res = report_execute($nufw_cmd,$result1);
                  }
		  //generate rescue rules
		  $nupyf_args = gen_nupyf_args($std_rules_dir,'dispatch_rules.tmp','forward_rules.tmp',$input_rules,$output_rules,$nat_rules,true, $mangle_rules);
                  $nupyf_args.= " --sortid $used_desc";
                  if ($l7_firewall)
                  {
                    $nupyf_args.= " --nulayer7";
                  }
		  if ($disable_check_net == true)
		  {
		    $nupyf_args.= " --no-check-net";
		  }
		  $nupyf_cmd = $nupyf_command.$nupyf_args." --ulog $network_desc_dir/$desc_file $datadir/$file 2>&1";
		  //add_log($nupyf_cmd);
		  $nupyf_res2 = report_execute($nupyf_cmd,$result2);

                  /* run nuperiod to generate nuauth xml periods file */
                  $periods_file = $rules_dir.'/periods.xml.tmp';
                  $nuperiod_cmd = "$nuperiod_command -f $datadir/$file -o $periods_file 2>&1";
                  $nuperiod_res = report_execute($nuperiod_cmd, $result_periods);
	          if (($result0!=0) or ($result1!=0) or ($result2!=0) or ($result_periods != 0)){
                    /* display specific error messages */
                    if ($result0!=0){
	                add_log($mess_error);
	                add_log_pre($l7_res);
                    }
                    if(($result1!=0) or ($result2!=0)){
	                add_log($mess_error);
		        add_log_pre($nupyf_res);
		        add_log_pre($nupyf_res2);
                    }
                    if($result_periods!=0){
                        add_log($mess_error_periods);
		        add_log_pre($nuperiod_res);
                    }
		  }
	          else
	          {
	            //rename($rules_dir."/".$nufw_rules_file.".tmp",$rules_dir."/".$nufw_rules_file);
	            //rename($rules_dir."/".$std_rules_file.".tmp",$rules_dir."/".$std_rules_file)

		    rename_if_exists("$rules_dir/l7_rules.tmp","$rules_dir/l7_rules");
		    foreach(array($nufw_rules_dir,$std_rules_dir) as $the_dir){
		      rename_if_exists("$the_dir/nat_rules.tmp","$the_dir/nat_rules");
		      rename_if_exists("$the_dir/dispatch_rules.tmp","$the_dir/dispatch_rules");
		      rename_if_exists("$the_dir/forward_rules.tmp","$the_dir/forward_rules");
		      rename_if_exists("$the_dir/input_rules.tmp","$the_dir/input_rules");
		      rename_if_exists("$the_dir/output_rules.tmp","$the_dir/output_rules");
		      rename_if_exists("$the_dir/mangle_rules.tmp","$the_dir/mangle_rules");
		    }
                    rename_if_exists("$rules_dir/periods.xml.tmp","$rules_dir/periods.xml");
                    if ($support_duplication) {
	              add_log($mess_ok_redundant);
                    } else {
                      add_log($mess_ok);
                    }
	          }
          }
}

function f_reload_rules()
{
  global $reload_rules;
  global $reload_rules_type;
  global $nufw_firewall;
  global $sudo_command;
  global $firewall_script;
  global $mess_remote_rules_ok;
  global $mess_remote_rules_nok;
  global $mess_reload_rules_ok;
  global $mess_reload_rules_nok;
  global $support_duplication;
  global $duplication_script;
  global $rules_dir;
  global $ssh_user;
  global $ssh_host;
  global $remote_rules_dir;
  global $remote_sudo_command;
  global $remote_firewall_script;

          if ((isset($reload_rules)) and ($reload_rules==1))
          {
            if (isset($reload_rules_type))
            {
#            add_log("$sudo_command /etc/init.d/init-firewall start 2>&1 > $datadir/problems_log");
              $farg = $reload_rules_type == 'standard'? 'nonufw': 'start';
              if (!$nufw_firewall)
              {
                $farg='nonufw';
              }
              if ($support_duplication) {
                $ret = report_execute("$duplication_script $rules_dir $ssh_user $ssh_host $remote_rules_dir $remote_sudo_command $remote_firewall_script $farg 2>&1", $result);
                if ($result==0)
                {
                  add_log($mess_remote_rules_ok);
                }else{
                  add_log($mess_remote_rules_nok);
                  add_log_pre($ret);
                }
              }
              #print "$sudo_command /etc/init.d/init-firewall $farg 2>&1";
              //system("$sudo_command /etc/init.d/init-firewall $farg 2>&1 > $logdir/problems_log",$result);
              $ret = report_execute("$sudo_command $firewall_script $farg 2>&1",$result);

              if ($result==0)
              {
                add_log($mess_reload_rules_ok);
              }else{
                add_log($mess_reload_rules_nok);
		add_log_pre($ret);
              }
            }
          }

}


function generate_periods_file($acl_file){
    global $nupyf_command;
    global $manage_input;
    global $manage_output;
    global $manage_nat;
    global $nufw_rules_dir;
    global $std_rules_dir;
    global $network_desc_file;
    global $used_desc_file;
    global $network_desc_dir;
    global $datadir;
    global $mess_error;
    global $mess_ok;
    global $mess_ok_redundant;
    global $support_duplication;
    global $rules_modified;
    global $rules_dir;
    global $nupyf_ldap_file;
    global $nupyf_conf_file;
    global $desc_file;
    global $nuperiod_command;
    global $periods_file;


    if (is_array($network_desc_file))
    {
        $desc_file=$used_desc_file;
    }else{
        $desc_file=$network_desc_file;
    }


    /* run nuperiod to generate nuauth xml periods file */
    $nuperiod_cmd = "$nuperiod_command -f $datadir/$acl_file -o $periods_file";
    $nuperiod_res = report_execute($nuperiod_cmd, $result_periods);

    if($result_periods != 0){
        add_log($nuperiod_res);
    }
}

if (isset($save_and_apply) and $save_and_apply==1)
{
  session_start();
  $save_to_file=$_SESSION['xml_file'];
  $document=unserialize($_SESSION['document']);
  if (isset($save_to_file))
  {
    if ($document){
      if (!$show_subjects)
      {
        sync_subjects(&$document);
      }
      $result=save_file($document,$save_to_file,1);
      if(!$result)
      {
        add_log($mess_index_error_while_saving."$datadir/$save_to_file");
      }else{
      	add_log("File saved to $save_to_file");
      }
      $_SESSION['modified']=0;
      generate_rules($save_to_file);
      generate_periods_file($save_to_file);
      f_reload_rules();
    }else{
      display_openfile_menu();
    }
  }else{
    add_log("Bad filename : $save_to_file");
  }
}

if (isset($upload_file) and $upload_file=='up')
{
  $uploadfile = $tmpdir ."/" . basename($_FILES['userfile']['name']);
  //add_log($_FILES['userfile']['type']);
  if(! @new policy($_FILES['userfile']['tmp_name']) || basename($_FILES['userfile']['name'],'.xml') == $_FILES['userfile']['name']
      || ($_FILES['userfile']['type'] != '' && $_FILES['userfile']['type']!='text/xml')){
    display_openfile_menu();
  }
  elseif (!(move_uploaded_file($_FILES['userfile']['tmp_name'], $uploadfile)))
  {
    add_log($mess_pb_moving_file);
    //print_r($_FILES);
    //exit(0);
  }
  elseif (file_exists($datadir."/".basename($_FILES['userfile']['name'])))
    {
      add_log ($mess_file_exists);
    }
  elseif (!copy($uploadfile, $datadir."/".basename($_FILES['userfile']['name'])))
    add_log($mess_cant_create);
  if(file_exists($uploadfile))
    unlink($uploadfile);
  if(file_exists($_FILES['userfile']['tmp_name']))
    unlink($_FILES['userfile']['tmp_name']);
}

if (isset($input))
{
  if (!isset($used_desc_file))
  {
    add_log("No desc file?");
    log_and_exit(-1);
  }
  session_start();

  $desc_from_file = read_desc_file($used_desc_file);
  if ($desc_from_file === -1)
  {
    add_log($mess_index_desc_file_read_pb);
    log_and_exit(-1);
  }

  //read_file includes checking on filename
  $document=read_file($input);
  if ($document === -1)
  {
    add_log($mess_index_file_read_pb);
    log_and_exit(-1);
  }
#  $expolicy=unserialize($_SESSION['document']);
  $descs=&$document->descs;
#  print_r($descs);
#  print "-----------------\n";
#  print_r($document->ressources);
#  print "=================\n";

  $used_desc=find_used_desc($desc_from_file,$descs);
  if ($used_desc < 0)
  {
    #add_log("Creating desc :".$used_desc);
    build_new_desc($desc_from_file,&$descs);
    $used_desc=find_used_desc($desc_from_file,$descs);
    #add_log("NEW USED DESC : $used_desc");
#  }else{
#    add_log("MATCH : $used_desc");
  }
  #  print_r($descs);
  #  exit(0);
  $bichains = build_bichains($descs->elts[$used_desc]);
  #print_r($descs->elts[$used_desc]);
  $bichains = populate_bichains_max($bichains,$document->acls);

  if (!$show_subjects)
  {
    sync_subjects(&$document);
  }
  $subjects=&$document->subjects;
  $checked=check_objects_from_desc(&$subjects,$descs->elts[$used_desc]);

 if ($checked<0)
 {
   add_log("crap subjects");
 }
 $ressources=&$document->ressources;
 $checked=check_objects_from_desc(&$ressources,$descs->elts[$used_desc]);

 if ($checked<0)
 {
   add_log("crap ressources");
 }
 $_SESSION['used_desc']=$used_desc;
 $_SESSION['document']=serialize($document);
 $_SESSION['bichains']=serialize($bichains);

  if (check_acls_order_scheme($document->acls)!=0)
  {
    add_log("Sorry");
    log_and_exit(-1);
  }
  $document = check_acls_from_to($document,$descs->elts[$used_desc]);

#Let us check at least one group exists. If not, let us create it
$groups = &$document->groups;
if ((!isset($groups)) or ($groups->elts == array()))
{
  $new_group = array();
  $new_group{'name'} = 'default';
  $new_group{'enabled'} = 1;
  $group=new group($new_group,'data',$groups->new_id());
  $groups->add_elt($group);
}


#  print "Return : ";
#  print $document->acls->get_max_order(1,3);


#  print_r($document);
#  exit(0);
  if (! $document){
    display_openfile_menu();
  }else{
    $_SESSION['document']=serialize($document);
    $_SESSION['modified']=0;
    $_SESSION['xml_file']=$input;
#    add_log("SESSION : ".$_SESSION['xml_file']);
    add_log($input.$mess_index_file_was_loaded);
  }
}
else{ #We don't read and write at the same time, do we?
  $output=$_GET['output_file'];
  if (isset($output))
  {
    session_start();
    $document=unserialize($_SESSION['document']);
    if (!$show_subjects)
    {
      sync_subjects(&$document);
    }
    if ($output=='')
    {
      if ((isset($xml_download) and ($xml_download=='on')))
      {
        header('Content-type: binary/data');
        header('Content-Disposition: attachment; filename=acls.xml');
        $result=save_file($document,$output,0);
      }
      else
      {
        header('Content-type: text/xml');
        $result=save_file($document,$output,0);
      }
      exit(0);
    }else{
      $result=save_file($document,$output,1);
    }
    if($result)
    {
      if ($output!='')
        add_log("$datadir/$output".$mess_index_file_was_saved);
        $_SESSION['modified']=0;
    }else{
      add_log($mess_index_error_while_saving."$datadir/$output");
    }
  }else{ #We don't write and delete at the same time, do we?
    $delete=$_GET['delete_file'];
    if (isset($delete))
    {
      if(del_file($delete))
      {
        add_log("$datadir/$delete".$mess_index_file_was_deleted);
      }else{
        add_log($mess_index_error_while_deleting."$datadir/$delete");
      }
    }else{
      $forget=$_REQUEST['forget'];
      session_start();
#      if(isset($forget) and ($forget==1) and (isset($used_file)) and (preg_match('^/a-zA-Z0-9\.\-\_/$',$used_file)) and (!preg_match('/\.\./',$used_file)) and (file_exists($datadir.$used_file)))
      if(isset($forget) and ($forget==1))
      {
        add_log($mess_index_forget_all);
        forget_nuface_session();
      } else {
        if ((isset($generate)) and ($generate==1))
        {
            if (is_array($network_desc_file))
            {
                $desc_file=$used_desc_file;
            }else{
                $desc_file=$network_desc_file;
            }
          if (filemtime($network_desc_dir."/".$desc_file) > filemtime($datadir."/".$used_file))
          {
            add_log($mess_desc_too_recent);
            log_and_exit(-1);
          }
          generate_rules($used_file);
          generate_periods_file($used_file);
#          if ($_SESSION['modified']!=0)
#          {
#            add_log($rules_modified);
#          }else{
#	#          add_log($nupyf_command." ".$network_desc_dir."/".$network_desc_file." ".$datadir."/".$used_file.">".$rules_dir."/".$nufw_rules_file);
#	#          add_log($nupyf_command." --std ".$rules_dir."/".$std_rules_file." ".$network_desc_dir."/".$network_desc_file." ".$datadir."/".$used_file);
#		  $input_rules = ($manage_input == 0)? '': 'input_rules.tmp';
#		  $output_rules = ($manage_output == 0)? '': 'output_rules.tmp';
#		  $nat_rules = ($manage_nat == 0)? '': 'nat_rules.tmp';
#		  $nupyf_args = gen_nupyf_args($nufw_rules_dir,'dispatch_rules.tmp','forward_rules.tmp',$input_rules,$output_rules,$nat_rules,false);
#                  $desc_file="";
#                  if (is_array($network_desc_file))
#                  {
#                    $desc_file=$used_desc_file;
#                  }else{
#                    $desc_file=$network_desc_file;
#                  }
#	          $nufw_cmd=$nupyf_command.$nupyf_args." --ulog --conf ".$network_desc_dir."/".$nupyf_conf_file." --dumpldap ".$rules_dir."/".$nupyf_ldap_file." ".$network_desc_dir."/".$desc_file." ".$datadir."/".$used_file." 2>&1";
#		  //add_log($nufw_cmd);
#	          //system($nufw_cmd,$result1);
#		  $nupyf_res = report_execute($nufw_cmd,$result1);
#		  //generate rescue rules
#		  $nupyf_args = gen_nupyf_args($std_rules_dir,'dispatch_rules.tmp','forward_rules.tmp',$input_rules,$output_rules,$nat_rules,true);
#		  $nupyf_cmd = $nupyf_command.$nupyf_args." --ulog $network_desc_dir/$desc_file $datadir/$used_file 2>&1";
#		  //add_log($nupyf_cmd);
#		  $nupyf_res2 = report_execute($nupyf_cmd,$result2);
#	          if (($result1!=0) or ($result2!=0)){
#	            add_log($mess_error);
#		    add_log($nupyf_res);
#		    add_log($nupyf_res2);
#		  }
#	          else
#	          {
#	            //rename($rules_dir."/".$nufw_rules_file.".tmp",$rules_dir."/".$nufw_rules_file);
#	            //rename($rules_dir."/".$std_rules_file.".tmp",$rules_dir."/".$std_rules_file)
#
#		    foreach(array($nufw_rules_dir,$std_rules_dir) as $the_dir){
#		      rename_if_exists("$the_dir/nat_rules.tmp","$the_dir/nat_rules");
#		      rename_if_exists("$the_dir/dispatch_rules.tmp","$the_dir/dispatch_rules");
#		      rename_if_exists("$the_dir/forward_rules.tmp","$the_dir/forward_rules");
#		      rename_if_exists("$the_dir/input_rules.tmp","$the_dir/input_rules");
#		      rename_if_exists("$the_dir/output_rules.tmp","$the_dir/output_rules");
#		    }
#	            if ($support_duplication) {
#	              add_log($mess_ok_redundant);
#                  } else {
#                    add_log($mess_ok);
#                  }
#	          }
#          }
        }else{
          if (isset($reload_by_hand) and ($reload_by_hand==1))
          {
            f_reload_rules();
          }
        }
      }
    }
  }
}

$expolicy=unserialize($_SESSION['document']);
$files=file_list();
require_once ("include/headers.php");
if(isset($edw_wiz) && $edw_wiz==4){
    echo "<script type=\"text/javascript\">
    window.onload = function(){
        hide_all();
        montre_global('top','top1');
        montre('action1');
    }

    </script>";
    add_log("You may choose a file and reload rules");
}
if (!$expolicy) {
    echo "<script type=\"text/javascript\">
    window.onload = function(){
        montre_global('top','top1');
    }
</script>";
    }
?>

<div class="menu">
<a href="#"><h2 onclick="javascript:montre_global('top','top1')"><?php echo $mess_files;?></h2></a>
<div class="level1" id="top1">
<?php
  print "<div class=menucat> \n<a href='#'
  onclick=\"javascript:montre('action1');\"><h3>$mess_index_load_conf_from_file</h3></a>";
if (!$expolicy){
  display_openfile_menu();
}else{
  print $mess_index_file_already_loaded;
}
print "</div>";
print "<div class=menucat >";
if ($expolicy){
  print "<a  href='#' onclick=\"javascript:montre('action2');\"  ><h3>$mess_index_save_conf_to_file</h3></a>";

  echo "<div class='action' id='action2'><form><select name=\"output_file\">";
    if (!isset($files))
    {
      $files=array();
    }
    foreach($files as $file){
      echo "    <option>$file</option>\n";
    }
  echo " </select>";
  print " <INPUT type=\"submit\" value=\"$mess_index_button_overwrite\" class=\"button\">";
  ?>
  </form>
  </div>
  </div>
  <div class=menucat >
  <a  href='#' onclick="javascript:montre('action7');"  ><h3><?php echo $mess_index_save_new_file; ?></h3></a>
  <div class='action' id='action7'>
  <form action="index.php">
    <input type="text" name="output_file">

  <?php
  print "  <input type=\"submit\" value=\"".$mess_index_button_new."\" class=\"button\">";
  echo "</form></div>";
}
?>
</div>

<div class=menucat >
<a  href='#' onclick="javascript:montre('action9');"   ><h3><?php echo $mess_index_upload_file ?></h3></a>

<div class='action' id='action9'>

<form enctype="multipart/form-data" action="index.php" method="post">
<input type="hidden" name="upload_file" value="up"/>
<input type="hidden" name="MAX_FILE_SIZE" value="300000" />
<?php echo $mess_send_file; ?> <input name="userfile" type="file" />
<input type="submit" value="<?php echo $mess_send_file;?>" />
</form>

</div>

</div>

<div class='menucat' ><a  href='#'>
<?php
print "<h3  onclick=\"javascript:montre('action5');\"   >$mess_index_delete_a_saved_file</h3></a>";
?>
<div class='action' id='action5'>
<?php
echo "<form onsubmit=\"return confirm('$mess_index_confirm_deletion');\">";
?>
 <select name="delete_file">
<?php
    if (!isset($files))
    {
      $files=array();
    }
    foreach($files as $file){
      echo "    <option>$file</option>\n";
    }
?>
 </select>
<?php
print "<INPUT type=\"submit\" value=\"$mess_index_button_delete\" class=\"button\">";

 //echo '<br />'.$mess_index_confirm_deletion.'<input type="checkbox" id="confirm_delete" name="confirm_delete"/>';
echo "</form></div>";
?>

</div>
</div>


<a href="#"><h2 onclick="javascript:montre_global('top','top2')"><?php echo $mess_rules;?></h2></a>
<div class='level1' id='top2'>
<div class='menucat'>
<a href='#'  onclick="javascript:montre('action3');" >
<h3  ><?php print "$mess_title_rules"; ?></h3>
</a>
<div class='action' id='action3'>
<form action="index.php" method=POST>
  <input type="hidden" name=generate value=1>
 <select name="used_file">";
<?php
    if (!isset($files))
    {
      $files=array();
    }
    foreach($files as $file){
      echo "    <option>$file</option>\n";
    }
print "</select>";
if (is_array($network_desc_file))
{
  print "<br>$mess_desc_file_choice";
  print " <select name=\"used_desc_file\">";
  foreach($network_desc_file as $file){
      echo "    <option>$file</option>\n";
  }
  print "</select>";
}
print "  <input type=\"submit\" value=\"$mess_index_generate_rules\" class=\"button\">";
?>
</form>
</div>

</div>
<div class='menucat'  ><a  href='#'  onclick="javascript:montre('action4');"  >
<?php
if ($support_duplication) {
  print "<h3>$mess_reload_redundant_rules</h3></a>";
} else {
  print "<h3>$mess_reload_rules</h3></a>";
}
?>
<div class='action' id='action4'><form>
<input type=hidden name=reload_by_hand value=1>
<?php
if ($nufw_firewall)
{
  print "<select name=\"reload_rules_type\" >";
  print " <option>nufw</option>";
  print "<option>standard</option>";
  print "</select>\n";
}else{
  print "<input type=\"hidden\" name=\"reload_rules_type\" value=\"standard\">\n";
}
if ($support_duplication) {
  print "<input type=\"submit\" value=\"$mess_reload_redundant_rules\" class=\"button\">";
} else {
  print "<input type=\"submit\" value=\"$mess_reload_rules\" class=\"button\">";
}
?>
<input type="hidden" value="1" name="reload_rules">
</form>
</div>
</div>
</div>

<?php
if ($expolicy){
?>
<a href="#"><h2 onclick="javascript:montre_global('top','top3')"><?php echo $mess_session;?></h2></a>
<div class="level1" id="top3">
<div class=menucat >
<a  href='#' onclick="javascript:montre('action8');"   ><h3><?php echo $mess_index_get_session; ?></h3></a>
<div class='action' id='action8'> <form>
<?php
echo "  <input type=hidden name=\"output_file\" value=\"\">";
print "  <input type=\"submit\" value=\"$mess_index_button_dump_on_screen\" class=\"button\">";
print " <input type=\"checkbox\" name=\"xml_download\">$mess_save_to_file";
?>

</form>
</div>
</div>


<div class='menucat' >
<a  href='#'  onclick="javascript:montre('action6');"  >
<?php
print "<h3>$mess_index_forget_this_session</h3>";
?>
</a>
<div class='action' id='action6'>
<?php
  print $mess_index_all_changes_discarded;
  print "<form action=\"index.php\" method=POST>";
  print "<input type=\"hidden\" name=\"forget\" value=\"1\">";
  print "<input type=\"submit\" value=\"$mess_index_button_forget_all\" class=\"button\">";
  print "</form>";
}
?>
</div>
</div>
</div>
</div>
<?php
begin_content_detail();
if ($expolicy){
?>
  <FORM action="index.php" method="post">
    <input type="hidden" name="save_and_apply" value="1">
<?php
if (is_array($network_desc_file))
{
  print "<br>$mess_desc_file_choice";
  print " <select name=\"used_desc_file\">";
  foreach($network_desc_file as $file){
      echo "    <option>$file</option>\n";
  }
  print "</select>";
}
?>
<input type=hidden name="reload_rules" value="1">
<?php
if ($nufw_firewall)
{
  print "<select name=\"reload_rules_type\" >";
  print " <option>nufw</option>";
  print "<option>standard</option>";
  print "</select>\n";
}else{
  print "<input type=\"hidden\" name=\"reload_rules_type\" value=\"standard\">\n";
}
if ($support_duplication) {
  print "<input type=\"submit\" value=\"$mess_reload_redundant_rules\" class=\"button\">";
} else {
  print "<input type=\"submit\" value=\"$mess_reload_rules\" class=\"button\">";
}

}
echo "</form>";

end_content_detail();
require_once ("include/footer.php");
?>
