<?php
#
# Copyright(C) 2004-2005 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#            Jean Gillaux <jean@inl.fr>
#            Damien Boucard <damien.boucard AT inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

session_start();
$title="periods";
$singtitle="period";
require_once ("/etc/nuface/config.php");
require_once ("include/headers.php");
require_once ("include/function.php");
require_once ("include/types.php");
require_once ("include/messages.php");


$elt=-1;$sub_elt=-1;
$in_elt=0;

$elt=$_REQUEST['elt'];
if (!check_nb($elt))
  $elt=-1;
$sub_elt=$_REQUEST['sub_elt'];
if (!check_nb($sub_elt))
  $sub_elt=-1;



$expolicy=unserialize($_SESSION['document']);
$floating=unserialize($_SESSION['floating_elts']);
if (!isset($floating) or ($floating==''))
{
  $floating=array();
}
#print_r($exppolicy);
if (!$expolicy){
  display_openfile_menu();
#  add_log($gal_load_valid_xml_file);
  log_and_exit(-1);
}
$periods=&$expolicy->periods;

$ress = &$periods->list_tab();

$del=0;
$set=$_REQUEST['set'];
$elt_set=$_REQUEST['elt_set'];
$elt_del=$_REQUEST['elt_del'];
#$add_float=$_REQUEST['add_float'];
$add_float_elt=$_REQUEST['elt'];
$copy=$_REQUEST['copy'];
$new_period=$_REQUEST['new_period'];
$new_name=$_REQUEST['name'];
$new_op=$_REQUEST['op'];
$add_float=array();
$i=1;
foreach ($_REQUEST as $req=>$val)
{
  if (preg_match("/^add_float_(\d+)$/",$req,$matches)){
    $add_float[$matches[1]]=$val;
  }
}
if (count($add_float)==0)
{
  unset($add_float);
}

#INPUT checking
if (!check_array_of_nb($add_float))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}
if (!check_nb($add_float_elt))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}




if ($set == 1) #New value was set
{
  if (!isset($elt) or ($elt==-1)){
    add_log($gal_bad_param);
    log_and_exit(-1);
  }
  if (!isset($sub_elt) or ($sub_elt==-1)){
    add_log($gal_bad_param);
    log_and_exit(-1);
  }
  $my_elt=&$periods->get_elt($elt);
  $my_sub_elt=&$my_elt->get_elt($sub_elt);
  $tab=$my_sub_elt->get_obj();
  $received['ID']=$tab{'ID'};
  $seen_mod=0;
  foreach (possible_fields('elt',$tab{'type'}) as $tabkey){
    if ($tabkey!='ID')
      $received{$tabkey}=$_REQUEST[$tabkey];
#    print "Setting $tabkey to ".$received[$tabkey]."<br>";
    if (($tabkey!='modified') and ($tabkey!='comment'))
    {
      if ((!isset($received[$tabkey]) and ($tabkey!='periodtype') and ($tabkey!='start') and ($tabkey!='stop') and ($tabkey!='duration'))){
        add_log($gal_missing_param_specified.$tabkey.")");
        log_and_exit(-1);
      }
    }
    $ret=check_input_var('elt',$tabkey,$received[$tabkey]);
    if ($ret!=0)
    {
      add_log($gal_bad_param_specified.$tabkey.")");
      add_log($mess_bad_input_var{$ret});
      log_and_exit(-1);
    }
    if ($received[$tabkey] != $tab[$tabkey])
    {
      if (($tabkey!='ID') and ($tabkey!='type') and ($tabkey!='modified'))
      {
        $seen_mod++;
      }
    }
  }
  if (($received['periodtype']!='duration') and (isset($received['duration'])))
  {
    unset($received['duration']);
  }
  if (!(($received['periodtype']=='duration') or ($received['periodtype'])=='' or (!isset($received['periodtype']))))
  {
    if ((!isset($received['start'])) or $received['start']=='')
    {
      add_log($gal_missing_param_specified.'start'.")");
      log_and_exit(-1);
    }
    if ((!isset($received['stop'])) or $received['stop']=='')
    {
      add_log($gal_missing_param_specified.'stop'.")");
      log_and_exit(-1);
    }
    if ($received['start']>$received['stop'])
    {
      add_log($mess_start_inf_stop);
      log_and_exit(-1);
    }
  }
  if ($received['periodtype']=='days')
  {
    if ($received['start']<1)
    {
      add_log('start'.$mess_too_low);
      log_and_exit(-1);
    }
    if ($received['stop']<1)
    {
      add_log('stop'.$mess_too_low);
      log_and_exit(-1);
    }
    if ($received['start']>7)
    {
      add_log('start'.$mess_too_high);
      log_and_exit(-1);
    }
    if ($received['stop']>7)
    {
      add_log('stop'.$mess_too_high);
      log_and_exit(-1);
    }
  }
  if ($received['periodtype']=='hours')
  {
    if ($received['start']<0)
    {
      add_log('start'.$mess_too_low);
      log_and_exit(-1);
    }
    if ($received['stop']<0)
    {
      add_log('stop'.$mess_too_low);
      log_and_exit(-1);
    }
    if ($received['start']>23)
    {
      add_log('start'.$mess_too_high);
      log_and_exit(-1);
    }
    if ($received['stop']>23)
    {
      add_log('stop'.$mess_too_high);
      log_and_exit(-1);
    }

  }
  if ($received['periodtype']=='duration')
  {
    unset($received['start']);
    unset($received['stop']);
    if ((!isset($received['duration'])) or $received['duration']=='')
    {
      add_log($gal_unneeded_param_specified.'duration'.")");
      log_and_exit(-1);
    }
  }
#  if (($received['proto']!='tcp') and ($received['proto']!='udp') and (isset($received['sport']) and ($received['sport']!='')))
#  {
#    add_log($gal_unneeded_param_specified.'sport'.")");
#    log_and_exit(-1);
#  }
#  if (($received['proto']!='tcp') and ($received['proto']!='udp') and (isset($received['dport']) and ($received['dport']!='')))
#  {
#    add_log($gal_unneeded_param_specified.'dport'.")");
#    log_and_exit(-1);
#  }
  $received['type']=$tab['type'];
  unset($received['ID']);

##Sanity checking
##  if ($received['type'] == 'ipv4'){
##    if ((!isset($received['proto'])) or ($received['proto']=='icmp') or ($received['proto']=='') or ($received['proto']=='--'))
##    {
##      if ((isset($received['dport'])) and ($received['dport']!=''))
##      {
##        add_log($gal_missing_dport_nonsense);
##        log_and_exit(-1);
##      }
##      if ((isset($received['sport'])) and ($received['sport']!=''))
##      {
##        add_log($gal_missing_sport_nonsense);
##        log_and_exit(-1);
##      }
##    }
##  }

  $linkid=0;
  if (isset($received['linkid'])){//Perform a name resolution on received parameter
    if (!isset($ress))
    {
      $ress=array();
    }
    foreach ($ress as $key=>$val){
      if ($val==$received['linkid'])
      {
        $linkid=$key;
        break;
      }
    }
    if ($linkid==0){
      add_log($gal_missing_bad_linkid_param);
      log_and_exit(-1);
    }else{
      $received['linkid']=$linkid;
    }
  }
  $my_elt->del_elt($tab['ID']);
  if ($seen_mod){
    $received['modified'] = date("D d M Y");
  }
  $new_elt=new elt($received,'data',$tab['ID']);
  $my_elt->add_elt($new_elt);
#  print_r($expolicy);
  $_SESSION['document']=serialize($expolicy);
  $_SESSION['modified']=1;
  $_SESSION['need_acl_recalc']=1;
}else{
  $del=$_REQUEST['del'];
  if (isset($del) and ($del==1))
  {
    if (!isset($elt) or ($elt==-1)){
      add_log($gal_bad_param);
      log_and_exit(-1);
    }
    if (!isset($sub_elt) or ($sub_elt==-1)){
      add_log($gal_bad_param);
      log_and_exit(-1);
    }
    $my_elt=&$periods->get_elt($elt);
    $my_sub_elt=&$my_elt->del_elt($sub_elt);
    $_SESSION['document']=serialize($expolicy);
    $_SESSION['modified']=1;
    $_SESSION['need_acl_recalc']=1;
    unset($sub_elt);
  }else{
    if (isset($elt_set) and ($elt_set==1))
    {
      if (!isset($elt) or ($elt==-1)){
        add_log($gal_bad_param);
        log_and_exit(-1);
      }
      $my_elt=&$periods->get_elt($elt);
      $tab=$my_elt->get_obj();
      $received['ID']=$tab{'ID'};
      $seen_mod=0;
      foreach (possible_fields('period') as $tabkey){
        if ($tabkey!='ID')
          $received{$tabkey}=$_REQUEST[$tabkey];
#        print "Setting $tabkey to ".$received[$tabkey]."<br>";
        if ((!isset($received[$tabkey])) and ($tabkey!='modified')){
          add_log($gal_missing_param_specified.$tabkey.")");
          log_and_exit(-1);
        }
        $ret=check_input_var('ress',$tabkey,$received[$tabkey]);
        if ($ret!=0)
        {
          add_log($gal_bad_param_specified.$tabkey.")");
          add_log($mess_bad_input_var{$ret});
          log_and_exit(-1);
        }
        if (($received[$tabkey] != $tab[$tabkey]) and ($tabkey!='modified'))
        {
          $seen_mod++;
          $my_elt->modify_param($tabkey,$received[$tabkey]);
        }
      }
      unset($received['ID']);
      if ($seen_mod)
      {
        $my_elt->modify_param('modified',date("D d M Y"));
      }
#      $protocols->del_elt($tab['ID']);
#      $new_elt=new protocol($received,'data',$tab['ID']);
#      $protocols->add_elt($new_elt);
      $_SESSION['document']=serialize($expolicy);
      $_SESSION['modified']=1;
      $_SESSION['need_acl_recalc']=1;
    }else{
      if (isset($elt_del) and ($elt_del==1))
      {
        if (!isset($elt) or ($elt==-1)){
          add_log($gal_bad_param);
          log_and_exit(-1);
        }
        $periods->del_elt($elt);
        $_SESSION['document']=serialize($expolicy);
        $_SESSION['modified']=1;
        $_SESSION['need_acl_recalc']=1;
        $elt=-1;
      }else{
#        if (isset($new_elt) and ($new_elt==1))
#        {
#          $type=$_REQUEST['type'];
#          if (check_input_var('elt','type',$type)!=0)
#          {
#            print "Sorry, bad type received!";
#            log_and_exit(-1);
#          }
#          if ((!isset($type)) or ($type==''))
#          {
#            print "Sorry, didn't receive a type!";
#            log_and_exit(-1);
#          }
#          $received['type']=$type;
#          $new_elt=new elt($received,'data',max($protocols->get_max_elt_id(),max_elt($floating))+1);
#          array_push($floating,$new_elt);
#          $_SESSION['floating_elts']=serialize($floating);
#        }else{
          if (isset($add_float)){ #Adding an element from the floating panel
            if (!isset($add_float_elt)){
              add_log($gal_elt_not_set);
              log_and_exit(-1);
            }
            #We must check passed elements actually exist
            $working_elt=&$periods->get_elt($add_float_elt);
            if (!isset($working_elt)){
              add_log($gal_elt_not_exists);
              log_and_exit(-1);
            }
            $exists=1;
            if (!isset($floating))
            {
              $floating=array();
            }
            $reverse_floating = array();
            foreach($floating as $float)
            {
              $reverse_floating[$float->get_id()] = $float;
            }
            foreach($add_float as $id => $quantity) {
              if (!isset($reverse_floating[$id])) {
                $exists = 0;
                break;
              }
            }
            if ($exists != 1){
              add_log($gal_float_elt_not_exists);
              log_and_exit(-1);
            }
            foreach ($add_float as $id => $quantity) {
              for ($n=0; $n < $quantity; $n++) {
                $tmp=$reverse_floating[$id]->get_obj();
                $reverse_floating[$id]->datas['ID'] = max($periods->get_max_elt_id(),max_elt($floating))+1;
                $sub_elt = $reverse_floating[$id]->datas['ID'];

                if (($tmp['type'] == 'period') or ($tmp['type'] == 'link')){
                  $working_elt->add_elt($reverse_floating[$id]);
    #              print_r($working_elt);
                  $_SESSION['document']=serialize($expolicy);
                  $_SESSION['modified']=1;
                  $_SESSION['need_acl_recalc']=1;
                }else{
                  add_log($ress_bad_type);
                }
              }
            }

          }else{
            if (isset($copy) and ($copy==1))
            {
              if (!isset($elt) or ($elt==-1))
              {
                add_log($gal_elt_not_set);
                log_and_exit(-1);
              }
              if (!isset($sub_elt) or ($sub_elt==-1))
              {
                add_log($gal_sub_elt_not_set);
                log_and_exit(-1);
              }
              $my_elt=$periods->get_elt($elt);
              $my_sub_elt=$my_elt->get_elt($sub_elt);
              if (isset($my_sub_elt))
              {
                $my_sub_elt->datas{'ID'}=max_elt($floating)+1;
                array_push($floating,$my_sub_elt);
                $_SESSION['floating_elts']=serialize($floating);
              }

            }else{
              if ((isset($new_period)) and (isset($new_name)) and (isset($new_op)))
              {
                if (($new_period != 1) or (($new_op != 'or') and ($new_op != 'and'))){
                  add_log($gal_bad_param);
                  log_and_exit(-1);
                }
                $ret=check_input_var('ress','name',$new_name);
                if ($ret!=0)
                {
                  add_log($gal_bad_param);
                  add_log($mess_bad_input_var{$ret});
                  log_and_exit(-1);
                }

                $new_ress{'name'}=$new_name;
                $new_ress{'operator'}=$new_op;
                $elt = $periods->new_id();
                $new=new period($new_ress,'data',$elt);
                $periods->add_elt($new);
                $_SESSION['document']=serialize($expolicy);
                $_SESSION['modified']=1;
                $_SESSION['need_acl_recalc']=1;

              }

            }
          }
      }
    }
  }
}


$expolicy=unserialize($_SESSION['document']);
$floating=unserialize($_SESSION['floating_elts']);
if (!$expolicy){
  display_openfile_menu();
#  add_log($gal_load_valid_xml_file);
  log_and_exit(-1);
}
$periods=&$expolicy->periods;
$acls=$expolicy->acls;

$all_acls= $acls->list_tab();
$used=array();
if (!isset($all_acls))
{
  $all_acls=array();
}
foreach ($all_acls as $acl_id=>$aclname)
{
  $tmp_acl=$acls->get_elt($acl_id);
  if ((isset($tmp_acl->period)) and ($tmp_acl->period)!='')
    $used{$tmp_acl->period}++;
}
$used_link=array();
$all_elts=$periods->list_tab();
if (!isset($all_elts))
{
  $all_elts=array();
}
foreach ($all_elts as $id=>$eltname)
{
  $l_elt=$periods->get_elt($id);
  if(!isset($l_elt)){
    continue;
  }
  $all_sub_elts=$l_elt->list_tab();
  if (!isset($all_sub_elts))
  {
    $all_sub_elts=array();
  }
  foreach ($all_sub_elts as $sub_id=>$sub_eltname)
  {
    $tmp_sub_elt=$l_elt->get_elt($sub_id);
    if ($tmp_sub_elt->datas['type'] == 'link')
    {
      $used_link{$tmp_sub_elt->datas['linkid']}++;
    }
  }
  if ((!isset($elt) or ($elt==-1)) and (!isset($sub_elt) or ($sub_elt==-1)))
  {
    if (count($all_sub_elts)==0)
    {
      add_log($mess_incomplete_object);
      $elt=$id;
    }
  }
}

$ress = &$periods->list_tab();

echo "<div class=\"menu\">\n";
print "<img src=\"images/collapse.png\" onClick=\"hide_all_objects();\" title=\"$mess_collapse_all\"/>&nbsp<img src=\"images/expand.png\" onClick=\"show_all_objects();\" title=\"$mess_expand_all\"/>";
print "<ul id=\"containerul\">\n";
if (isset($ress) and $ress!='')
  $ress_array=array();
  $seen = array();
  if (!isset($ress))
  {
    $ress=array();
  }
  foreach ($ress as $key=>$res){
    if ($seen[$res]++<1)
      array_push($ress_array,$res);
    else
      add_log("$mess_duplicate_name_found".$res);
  }
  $ress_array and sort($ress_array);
  if (!isset($ress_array))
  {
    $ress_array=array();
  }
  foreach($ress_array as $res)
  {
    if (!isset($ress))
    {
      $ress=array();
    }
    foreach($ress as $key=>$foo)
    {
      if ($res == $foo)
        break;
    }
    $tmp = &$periods->get_elt($key);
    if(!isset($tmp)){
        continue;
    }
    $myress=$tmp->list_tab();
    $infos=$tmp->get_obj();
    echo "<li id=\"elt_$key\">";
    if (isset($used{$key}))
      print "<span class=\"used\">";
    elseif (isset($used_link{$key}))
      print "<span class=\"usedaslink\">";
    print "<a href=\"periods.php?elt=$key\"";
    if (isset($infos)){
      print " title=\"operator : ".$infos{'operator'}."\"";
    }
    echo "\">$res</a>";
    if ((isset($used{$key})) or (isset($used_link{$key})))
      print "</span>\n";
#   print_r($tmp);
    echo "<ul>\n";
    if (isset($myress))
      foreach ($myress as $key2=>$myres){
        echo "<li><a href=\"periods.php?elt=$key&sub_elt=$key2\"";
        $my_elt=$tmp->get_elt($key2);
        $tab=$my_elt->get_obj();
        if (isset($tab)){
          print " title=\"";
#          print "type: ".$tab{'type'}." ";
          if (isset($tab{'periodtype'}))
            print "periodtype: ".$tab{'periodtype'}." ";
          if ((isset($tab{'start'})) and ($tab{'start'}!=''))
            print "start: ".$tab{'start'}." ";
          if ((isset($tab{'stop'})) and ($tab{'stop'}!=''))
            print "stop: ".$tab{'stop'}." ";
          if ((isset($tab{'duration'})) and ($tab{'duration'}!=''))
            print "duration: ".$tab{'duration'}." ";
          print "\"";
        }
        echo ">$myres";
        $my_elt=$tmp->get_elt($key2);
        $tab=$my_elt->get_obj();
        if ($tab{'type'}=='link'){
#       $my_elt2=$protocols->get_elt($tab{'linkid'});
#       print_r($my_elt2);
#       print "(".$my_elt2['elts']->'name'.")";
        print " (".$ress[$tab{'linkid'}].")";

        }
        echo "</a></li>";
      }
    echo "</ul>";
  }
echo "</ul>";
?>
<script type="text/javascript">
<?php
if ($elt) {
  print "elt = \"$elt\";
";
} else {
  print "elt = \"\";
";
}
?>
initiate(elt);
</script>
<?php

echo "</div>";
$print="";

begin_content_detail();
#print "elt : $elt ; sub_elt : $sub_elt";
if (isset($elt) and ($elt!=-1)){
  $my_elt=$periods->get_elt($elt);
  if ((isset($sub_elt)) and ($sub_elt!=-1)){
    $my_sub_elt=$my_elt->get_elt($sub_elt);
    $tab=$my_sub_elt->get_obj();
    $elt_obj = $my_elt->get_obj();
    print "<div class=\"edit_tab\">\n";
    print "<h2>$string_period {$elt_obj{'name'}}</h2>\n";
    print "<h3>$gal_edition $string_element {$tab{'name'}}</h3>\n";
    print "<table><tr class=\"head\"><td>$gal_field</td><td>$gal_value</td><td>$gal_new_value</td></tr>\n";
    print "<form action=\"periods.php\" method=POST name=\"period\">\n";
    print "<input type=hidden name=elt value=$elt>\n";
    print "<input type=hidden name=sub_elt value=$sub_elt>\n";
    print "<input type=hidden name=set value=1>\n";
    foreach (possible_fields('elt',$tab{'type'}) as $tabkey)
    {
      $tabelt='';
      if ($tab{$tabkey}!='')
        $tabelt = $tab{$tabkey};
      if ($tabkey=='comment')
      {
          echo "</table><table><tr><td class=\"rowtitle\">Comment</td><td><textarea
          name=comment cols=29>";
          if (isset($tabelt))
            echo $tabelt;
          echo "</textarea></td></tr><table>";
      }else{
        print "<tr><td class=\"rowtitle\">$tabkey</td><td>";
        if ($tabkey!='linkid')
          print $tabelt;
        else
          print $ress[$tabelt];
        print "</td><td>";
        if ($types{'elt'}{$tabkey}{'edit'} == 1) //This field can be edited
        {
          $disabled='';
          if ($tabkey=='periodtype')
          {
            $disabled='onFocus="griser_period();" onChange="griser_period();"';
          }
          if ($tabkey=='name')
          {
            $disabled='onFocus="remove_dummy_name()"';
          }
          $possible_values=possible_values('elt',$tabkey);
          if ($possible_values==0) //No preconfigured value for this field
          {
              echo "<input type=\"text\" name=\"$tabkey\" value=\"$tabelt\" $disabled>\n";
          }else{
            echo "<select name=\"$tabkey\" $disabled>\n";
            $possible_values and sort($possible_values);
            foreach ($possible_values as $value)
            {
              print "  <option";
              if (($value == $tabelt) or (($tabkey=='linkid') and ($value==$ress[$tabelt])))
                echo " selected";
              print ">$value</option>\n";
            }
            echo "</select>\n";
          }
        }
      }
    echo "</td></tr>\n";
    }
    echo "</table><input type=submit value=\"$gal_button_apply\" class=\"button\" onMouseOver=\"griser_period();\" >";
    echo "</form>\n";
    echo "<form>";
    print "<input type=hidden name=elt value=$elt>\n";
    print "<input type=hidden name=sub_elt value=$sub_elt>\n";
    print "<input type=hidden name=del value=1>\n";
    echo "<input type=submit value=\"$mess_index_button_delete\" class=\"button\">";
    echo "</form>";
    echo "<form action=\"periods.php\" action=POST>";
    print "<input type=hidden name=sub_elt value=$sub_elt>\n";
    print "<input type=hidden name=elt value=$elt>\n";
    print "<input type=hidden name=copy value=1>\n";
    echo "<input type=submit value=\"$gal_button_copy_to_floating\" class=\"button\">\n";
    echo "</form>";
    print "</div>\n";
  }else{
    $in_elt=1;
    $tab=$my_elt->get_obj();
    print "<div class=\"edit_tab\">\n";
    print "<h3>$gal_edition $string_period {$tab{'name'}}</h3>\n";
    print "<table><tr class=\"head\"><td>$gal_type</td><td>$gal_value</td><td>$gal_new_value</td></tr>\n";
    print "<form action=\"periods.php\" method=POST>\n";
    print "<input type=hidden name=elt value=$elt>\n";
    print "<input type=hidden name=elt_set value=1>\n";
    foreach(array('ID','name','operator','modified') as $tabkey){
      $tabelt='';
      if ($tab{$tabkey}!='')
        $tabelt = $tab{$tabkey};
      print "<tr><td class=\"rowtitle\">$tabkey</td><td>";
      print $tabelt;
      print "</td><td>";
      if ($types{'ress'}{$tabkey}{'edit'} == 1) //This field can be edited
      {
        $possible_values=possible_values('ress',$tabkey);
        if ($possible_values==0) //No preconfigured value for this field
        {
          echo "<input type=\"text\" name=\"$tabkey\" value=\"$tabelt\">\n";
        }else{
          echo "<select name=\"$tabkey\">\n";
          $possible_values and sort($possible_values);
          foreach ($possible_values as $value)
          {
            print "  <option";
            if (($value == $tabelt) or (($tabkey=='linkid') and ($value==$ress[$tabelt])))
              echo " selected";
            print ">$value</option>\n";
          }
          echo "</select>\n";
        }
      }
    }
    print "</td></tr></table>";
    print "<table><tr><td>Comment</td><td><textarea name=comment cols=28>";
    if (isset($tab{'comment'}))
    {
      print $tab{'comment'};
    }
    print "</textarea></td></tr></table>";
    print "<input type=submit value=\"$gal_button_apply\" class=\"button\">";
    print "</form>\n";
    if (!isset($used{$elt}) and (!isset($used_link{$elt})))
    {
    print "<form action=\"periods.php\" method=POST>\n";
    print "<input type=hidden name=elt value=$elt>\n";
    print "<input type=hidden name=elt_del value=1>\n";
    print "<input type=submit value=\"$mess_index_button_delete\" class=\"button\">";
    print "</form>";
    }

begin_acls_use();
  echo "<h3>$mess_used_in_acls</h3>";
show_acls_use(&$expolicy->acls,'period',$elt,$mess_unused_in_acls);
end_acls_use();


    print "</div>";
  }
}
end_content_detail();

init_floatings($floating);
$context{'period'} = 1;
$context{'link'} = 1;
show_floatings($context,$floating,$gal_working_elts,$gal_type,$gal_name,$gal_quantity,$gal_operation,$gal_button_add,$in_elt,$elt,$title);

require_once ("include/footer.php");
?>

